﻿Imports System
Imports System.Runtime.InteropServices

Public Class ClassPanoramaCommon
    '*! -----------------------------------------------------------------------------
    '*	@section	: Constant values.
    '* ------------------------------------------------------------------------------
    '
    Public Const NORMAL As Integer = 0                          ' Successful
    Public Const ERR_FILE_OPEN As Integer = -1                  ' Failed to file open.
    Public Const ERR_NO_MEMORY As Integer = -2                  ' Free memory is empty.
    Public Const ERR_PARAM As Integer = -3                      ' Invalid parameter.
    Public Const ERR_OBJ As Integer = -4                        ' State is invalid.
    Public Const ERR_NO_DATA As Integer = -5                    ' No data.
    Public Const ERR_INTERNAL_PARAM As Integer = -6             ' Invalid internal parameter.
    Public Const ERR_INTERNAL_PROC As Integer = -7              ' Internal error.
    Public Const ERR_NO_SUPPORT As Integer = -8                 ' Unsupported.
    Public Const ERR_INTERNAL_NO_DUTY As Integer = -9           ' No duty data.
    Public Const ERR_INVALID_ENVIRONMENT As Integer = -10       ' Invalid Environment.

    Public Const ERR_ICCTBLFILE_OPEN As Integer = -101          ' Failed to ICC file open.
    Public Const ERR_ICCTBLFILE_NODATA As Integer = -105        ' Failed to ICC file open.
    Public Const ERR_ICCTBLFILE_FORMAT As Integer = -110        ' Failed to ICC file open.
    Public Const ERR_ICCPROFILE_OPEN As Integer = -201          ' Failed to ICC file open.
    Public Const ERR_ICCPROFILE_INIT As Integer = -206          ' Error in Create convert object of ICM.
    Public Const ERR_ICCPROFILE_PROC As Integer = -207          ' ICM conversion failure.

    Public Const ERR_LUTFILE_OPEN As Integer = -300             ' Failed to Look-up table file open.
    Public Const ERR_LUTFILE_NODATA As Integer = -305           ' No data.
    Public Const ERR_LUTFILE_FORMAT As Integer = -310           ' File format error of LUT file.
    Public Const ERR_LUTFILE_ELM_TOOSMALL As Integer = -311     ' Element number of LUT file is too small.


    Public Const ERR_CORRFILE_OPEN As Integer = -400            ' Failed to Correction table file open.
    Public Const ERR_CORRFILE_NODATA As Integer = -405          ' No data.
    Public Const ERR_CORRFILE_FORMAT As Integer = -410          ' File format error of the Correction table file.
    Public Const ERR_CORRFILE_DUPLICATE As Integer = -411       ' Duplicate data.

    '*! -----------------------------------------------------------------------------
    '*	@section	: External library(DLL) interface definitions.
    '* ------------------------------------------------------------------------------

    <StructLayout(LayoutKind.Sequential, Pack:=4)> _
    Public Structure StructDivideParam
        Public numOfDiv As UInt32       ' Number of divided.
        Public overlapWidth As UInt32   ' Overlap width. [dot]
        Public srcWidth As UInt32       ' Width of source image data. [dot]
        Public srcHeight As UInt32      ' Height of source image data. [dot]
        Public dstWidth As UInt32       ' Width of the divided image data.	[dot]
        Public dstHeight As UInt32      ' Height of the divided image data.	[dot]
    End Structure

    <StructLayout(LayoutKind.Sequential, Pack:=4)> _
    Public Structure StructPanoramaImageParam
        Public overlapWidth As UInt32   ' Overlap width. [dot]
        Public srcWidth As UInt32       ' Width of source image data. [dot]
        Public srcHeight As UInt32      ' Height of source image data. [dot]
    End Structure

    <StructLayout(LayoutKind.Sequential, Pack:=4)> _
    Public Structure StructDutyImageParam
        Public srcWidth As UInt32       ' Width of source image data. [dot]
        Public srcHeight As UInt32      ' Height of source image data. [dot]
        Public dutyY As Double          ' Yellow duty. [0,,1.5]
        Public dutyM As Double          ' Magenta duty. [0,,1.5]
        Public dutyC As Double          ' Cyan duty. [0,,1.5]
    End Structure

    <StructLayout(LayoutKind.Sequential, Pack:=4)> _
    Public Structure StructDutyOfLUTFile
        Public pos As UInt32            ' Location in the Look-up table to get the Duty.
        Public scale As UInt32          ' For memory padding.
        Public resRhsDutyY As Double    ' RHS duty Y defined by LUT file. (Output)
        Public resRhsDutyM As Double    ' RHS duty M defined by LUT file. (Output)
        Public resRhsDutyC As Double    ' RHS duty C defined by LUT file. (Output)
        Public resLhsDutyY As Double    ' LHS duty Y defined by LUT file. (Output)
        Public resLhsDutyM As Double    ' LHS duty M defined by LUT file. (Output)
        Public resLhsDutyC As Double    ' LHS duty C defined by LUT file. (Output)
    End Structure

End Class
