﻿Imports System.Windows.Forms

Public Class DlgPortSelecter

    Private m_printerName As String = "-"
    Private m_portName As String = ""
	Private nameTbl() As String

	Public ReadOnly Property PrinterName() As String
		Get
			Return m_printerName
		End Get
	End Property

	Public ReadOnly Property PortName() As String
		Get
			Return m_portName
		End Get
	End Property

	Private Sub DlgPortSelecter_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

		' Printer connected?
        If MakePortList() = 0 Then
            MessageBox.Show("Connected printer could not found.", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
            Me.Close()
        End If

	End Sub

	Private Sub OK_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OK_Button.Click

		' Set printer names.
		m_printerName = nameTbl(ComboBox_Port.SelectedIndex)
		m_portName = GetPortName(m_printerName)

		Me.DialogResult = System.Windows.Forms.DialogResult.OK
		Me.Close()
	End Sub

	Private Sub Cancel_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Cancel_Button.Click
        Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
		Me.Close()
	End Sub

	' Make the printer name list. return values is number of printer connected.
	Private Function MakePortList() As Integer
		Dim portName As String
		Dim printerName As String
		Dim i As Integer = 0

		ComboBox_Port.Items.Clear()

		' Search connected printers. (only connection by USB)
		For Each printerName In Printing.PrinterSettings.InstalledPrinters
			portName = GetPortName(printerName)
			If portName <> "" Then
				If portName.IndexOf("USB") >= 0 Then
					ReDim Preserve nameTbl(i)
					nameTbl(i) = printerName
					ComboBox_Port.Items.Add(printerName)
					i += 1
				End If
			End If
		Next

		If i > 0 Then
			ComboBox_Port.SelectedIndex = 0
		End If

		Return i
	End Function

	Private Sub Exit_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Exit_Button.Click
		End
	End Sub
End Class
