﻿Imports System.Runtime.InteropServices
Imports System.Drawing
Imports System.Drawing.Imaging

Public Class BitmapAccess
	Private m_bitmapData As BitmapData
	Private m_rawData() As Byte

	Public Function LoadRawData(ByRef bmpTarget As Bitmap, Optional ByVal mode As ImageLockMode = ImageLockMode.ReadWrite) As Byte()
		Dim rect As Rectangle

		rect.X = 0
		rect.Y = 0
		rect.Width = bmpTarget.Width
		rect.Height = bmpTarget.Height

		m_bitmapData = bmpTarget.LockBits(rect, mode, bmpTarget.PixelFormat)

        ReDim m_rawData((m_bitmapData.Stride * m_bitmapData.Height) - 1)

		Marshal.Copy(m_bitmapData.Scan0, m_rawData, 0, m_rawData.Length)

		Return m_rawData
	End Function

	Public Sub StoreRawData(ByRef bmpTarget As Bitmap)

		Marshal.Copy(m_rawData, 0, m_bitmapData.Scan0, m_rawData.Length)

		bmpTarget.UnlockBits(m_bitmapData)

	End Sub

End Class
