﻿Module BmpDrawUtil
	'*! -----------------------------------------------------------------------------
    '*	@brief	: General purpose API for character drawing
	'*	@detail	:
	'*	@param	:	
	'*	@return	:	
	'*
	'* ------------------------------------------------------------------------------
	Public Sub DrawString(ByRef bmp As Bitmap, ByVal x As Integer, ByVal y As Integer, ByRef str As String)
		Dim prtFont As Font
		Dim prtBrushF As Brush
		Dim prtBrushB As Brush
		Dim gc As Graphics
		gc = Graphics.FromImage(bmp)

        prtFont = New Font("Arial", 28)
		prtBrushF = Brushes.DimGray
		prtBrushB = Brushes.Orange

		gc.DrawString(str, prtFont, prtBrushB, x + 2, y + 2)
		gc.DrawString(str, prtFont, prtBrushF, x, y)

		prtFont.Dispose()
		Return
	End Sub

	'*! -----------------------------------------------------------------------------
    '*	@brief	: General purpose API for character drawing
	'*	@detail	:
	'*	@param	:	
	'*	@return	:	
	'*
	'* ------------------------------------------------------------------------------
	Public Sub DrawString(ByRef gc As Graphics, ByVal x As Integer, ByVal y As Integer, ByRef str As String)
		Dim prtFont As Font
		Dim prtBrushF As Brush
		Dim prtBrushB As Brush

        prtFont = New Font("Arial", 28)
		prtBrushF = Brushes.DimGray
		prtBrushB = Brushes.Orange

		gc.DrawString(str, prtFont, prtBrushB, x + 2, y + 2)
		gc.DrawString(str, prtFont, prtBrushF, x, y)

		prtFont.Dispose()
		Return
	End Sub

	'*! -----------------------------------------------------------------------------
	'*	@brief	:
	'*	@detail	:
	'*	@param	:	
	'*	@return	:	
	'*
	'* ------------------------------------------------------------------------------
	Public Sub FillBitmap(ByRef bmp As Bitmap, ByVal clr As Color)
		Dim gc As Graphics = Graphics.FromImage(bmp)
		Dim bsh As Brush

		bsh = New SolidBrush(clr)

		gc.FillRectangle(Brushes.White, 0, 0, bmp.Width, bmp.Height)

		gc.FillRectangle(bsh, 0, 0 + 100, bmp.Width, bmp.Height - 100)

		gc.Dispose()
	End Sub

	'*! -----------------------------------------------------------------------------
	'*	@brief	:
	'*	@detail	:
	'*	@param	:	
	'*	@return	:	
	'*
	'* ------------------------------------------------------------------------------
	Public Sub FillBitmap(ByRef bmp As Bitmap, ByVal clr As Color, ByRef rect As Rectangle)
		Dim gc As Graphics = Graphics.FromImage(bmp)
		Dim bsh As Brush

		bsh = New SolidBrush(clr)

        'Fill the all area with white
        gc.FillRectangle(Brushes.White, rect)

		gc.FillRectangle(bsh, rect)

		gc.Dispose()
	End Sub

End Module
