Option Strict Off
Option Explicit On
Imports System.Runtime.InteropServices

Module CommonDef
    '
    Public Const GROUP_USUALLY As Integer = &H10000
    Public Const GROUP_SETTING As Integer = &H20000
    Public Const GROUP_HARDWARE As Integer = &H40000
    Public Const GROUP_SYSTEM As Integer = &H80000
    Public Const GROUP_FLSHPROG As Integer = &H100000

    Public Const STATUS_ERROR As Integer = &H80000000

    Public Const STATUS_USUALLY_IDLE As Integer = GROUP_USUALLY Or &H1S
    Public Const STATUS_USUALLY_PRINTING As Integer = GROUP_USUALLY Or &H2S
    Public Const STATUS_USUALLY_STANDSTILL As Integer = GROUP_USUALLY Or &H4S
    Public Const STATUS_USUALLY_PAPER_END As Integer = GROUP_USUALLY Or &H8S
    Public Const STATUS_USUALLY_RIBBON_END As Integer = GROUP_USUALLY Or &H10S
    Public Const STATUS_USUALLY_COOLING As Integer = GROUP_USUALLY Or &H20S
	Public Const STATUS_USUALLY_MOTCOOLING As Integer = GROUP_USUALLY Or &H40S
    Public Const STATUS_USUALLY_STANDBY_MODE As Integer = GROUP_USUALLY Or &H8000I

    Public Const STATUS_SETTING_COVER_OPEN As Integer = GROUP_SETTING Or &H1S
    Public Const STATUS_SETTING_PAPER_JAM As Integer = GROUP_SETTING Or &H2S
    Public Const STATUS_SETTING_RIBBON_ERR As Integer = GROUP_SETTING Or &H4S
    Public Const STATUS_SETTING_PAPER_ERR As Integer = GROUP_SETTING Or &H8S
    Public Const STATUS_SETTING_DATA_ERR As Integer = GROUP_SETTING Or &H10S
    Public Const STATUS_SETTING_SCRAPBOX_ERR As Integer = GROUP_SETTING Or &H20S

    Public Const STATUS_HARDWARE_ERR01 As Integer = GROUP_HARDWARE Or &H1S
    Public Const STATUS_HARDWARE_ERR02 As Integer = GROUP_HARDWARE Or &H2S
    Public Const STATUS_HARDWARE_ERR03 As Integer = GROUP_HARDWARE Or &H4S
    Public Const STATUS_HARDWARE_ERR04 As Integer = GROUP_HARDWARE Or &H8S
    Public Const STATUS_HARDWARE_ERR05 As Integer = GROUP_HARDWARE Or &H10S
    Public Const STATUS_HARDWARE_ERR06 As Integer = GROUP_HARDWARE Or &H20S
    Public Const STATUS_HARDWARE_ERR07 As Integer = GROUP_HARDWARE Or &H40S
    Public Const STATUS_HARDWARE_ERR08 As Integer = GROUP_HARDWARE Or &H80S
    Public Const STATUS_HARDWARE_ERR09 As Integer = GROUP_HARDWARE Or &H100S
    Public Const STATUS_HARDWARE_ERR10 As Integer = GROUP_HARDWARE Or &H200S

    Public Const STATUS_SYSTEM_ERR01 As Integer = GROUP_SYSTEM Or &H1S

    Public Const STATUS_FLSHPROG_IDLE As Integer = GROUP_FLSHPROG Or &H1S
    Public Const STATUS_FLSHPROG_WRITING As Integer = GROUP_FLSHPROG Or &H2S
    Public Const STATUS_FLSHPROG_FINISHED As Integer = GROUP_FLSHPROG Or &H4S
    Public Const STATUS_FLSHPROG_DATA_ERR1 As Integer = GROUP_FLSHPROG Or &H8S
    Public Const STATUS_FLSHPROG_DEVICE_ERR1 As Integer = GROUP_FLSHPROG Or &H10S
    Public Const STATUS_FLSHPROG_OTHERS_ERR1 As Integer = GROUP_FLSHPROG Or &H20S

    Public Const CUTTER_MODE_STANDARD As Short = 0
    Public Const CUTTER_MODE_NONSCRAP As Short = 1
    Public Const CUTTER_MODE_2INCHCUT As Short = 120
    Public Const CUTTER_MODE_PANORAMA As Short = 1000

    Public Const RETENTION_MODE_OFF As Short = &H0S
    Public Const RETENTION_MODE_ON As Short = &H1S

    Public Const STATUS_PRINTABLE As Integer = &H0
    Public Const STATUS_HIGHTEMP_HEAD As Integer = &H1
    Public Const STATUS_HIGHTEMP_BOTH As Integer = &H11
    Public Const STATUS_OTHER_STATE As Integer = &H10000
    Public Const STATUS_COMM_ERROR As Integer = (-1)

    Public Const OVERCOAT_FINISH_GLOSSY As Integer = 0
    Public Const OVERCOAT_FINISH_MATTE1 As Integer = 1
    Public Const OVERCOAT_FINISH_MATTE2 As Integer = 2
    Public Const OVERCOAT_FINISH_MATTE3 As Integer = 3
    Public Const OVERCOAT_FINISH_FINEMATTE As Integer = 21
    Public Const OVERCOAT_FINISH_LUSTER As Integer = 22
    Public Const OVERCOAT_FINISH_PMATTE11 As Integer = 101
    Public Const OVERCOAT_FINISH_PMATTE12 As Integer = 121
    Public Const OVERCOAT_FINISH_PMATTE13 As Integer = 122

    'Resolution Code for CWD
    Public Const CWD_300DPI As UInt32 = &H0US
    Public Const CWD_600DPI As UInt32 = &H1US
    Public Const CWD_610DPI As UInt32 = &H2US
    Public Const CWD_620DPI As UInt32 = &H3US

    'Media Code for CWD
    Public Const CWD_RX1 As UInt32 = &H1US
    Public Const CWD_HQL As UInt32 = &H2US
    Public Const CWD_HDM As UInt32 = &H3US

    'For CV Printers Item
    Public Const CVG_USUALLY As Integer = &H10000
    Public Const CVG_SETTING As Integer = &H20000
    Public Const CVG_HARDWARE As Integer = &H40000
    Public Const CVG_SYSTEM As Integer = &H80000
    Public Const CVG_FLSHPROG As Integer = &H100000

    Public Const CVSTATUS_ERROR As Integer = &H80000000

    Public Const CVS_USUALLY_IDLE As Integer = CVG_USUALLY Or &H1S
    Public Const CVS_USUALLY_PRINTING As Integer = CVG_USUALLY Or &H2S
    Public Const CVS_USUALLY_STANDSTILL As Integer = CVG_USUALLY Or &H4S
    Public Const CVS_USUALLY_PAPER_END As Integer = CVG_USUALLY Or &H8S
    Public Const CVS_USUALLY_RIBBON_END As Integer = CVG_USUALLY Or &H10S
    Public Const CVS_USUALLY_COOLING As Integer = CVG_USUALLY Or &H20S
    Public Const CVS_USUALLY_MOTCOOLING As Integer = CVG_USUALLY Or &H40S
    Public Const CVS_USUALLY_STANDBY_MODE As Integer = CVG_USUALLY Or &H8000I

    Public Const CVS_SETTING_COVER_OPEN As Integer = CVG_SETTING Or &H1S
    Public Const CVS_SETTING_PAPER_JAM As Integer = CVG_SETTING Or &H2S
    Public Const CVS_SETTING_RIBBON_ERR As Integer = CVG_SETTING Or &H4S
    Public Const CVS_SETTING_PAPER_ERR As Integer = CVG_SETTING Or &H8S
    Public Const CVS_SETTING_DATA_ERR As Integer = CVG_SETTING Or &H10S
    Public Const CVS_SETTING_SCRAP_ERR As Integer = CVG_SETTING Or &H20S

    Public Const CVS_HARDWARE_ERR01 As Integer = CVG_HARDWARE Or &H1S
    Public Const CVS_HARDWARE_ERR02 As Integer = CVG_HARDWARE Or &H2S
    Public Const CVS_HARDWARE_ERR03 As Integer = CVG_HARDWARE Or &H4S
    Public Const CVS_HARDWARE_ERR04 As Integer = CVG_HARDWARE Or &H8S
    Public Const CVS_HARDWARE_ERR05 As Integer = CVG_HARDWARE Or &H10S
    Public Const CVS_HARDWARE_ERR06 As Integer = CVG_HARDWARE Or &H20S
    Public Const CVS_HARDWARE_ERR07 As Integer = CVG_HARDWARE Or &H40S
    Public Const CVS_HARDWARE_ERR08 As Integer = CVG_HARDWARE Or &H80S
    Public Const CVS_HARDWARE_ERR09 As Integer = CVG_HARDWARE Or &H100S
    Public Const CVS_HARDWARE_ERR10 As Integer = CVG_HARDWARE Or &H200S

    Public Const CVS_SYSTEM_ERR01 As Integer = CVG_SYSTEM Or &H1S

    Public Const CVS_FLSHPROG_IDLE As Integer = CVG_FLSHPROG Or &H1S
    Public Const CVS_FLSHPROG_WRITING As Integer = CVG_FLSHPROG Or &H2S
    Public Const CVS_FLSHPROG_FINISHED As Integer = CVG_FLSHPROG Or &H4S
    Public Const CVS_FLSHPROG_DATA_ERR1 As Integer = CVG_FLSHPROG Or &H8S
    Public Const CVS_FLSHPROG_DEVICE_ERR1 As Integer = CVG_FLSHPROG Or &H10S
    Public Const CVS_FLSHPROG_OTHERS_ERR1 As Integer = CVG_FLSHPROG Or &H20S

    Public PRNTER_NAME_DS621 As String = "DS-621"
    Public PRNTER_NAME_DS620 As String = "DP-DS620"
    Public PRNTER_NAME_DS820 As String = "DP-DS820"

    Public MEDIA_CLASS_NAME_RX As String = "Digital"
    Public MEDIA_CLASS_NAME_HQL As String = "Premium"
    Public MEDIA_CLASS_NAME_HDM As String = "Pure Premium"

	'---------------------------------------------------------
	' Get printer status
	'---------------------------------------------------------
	Function GetStateStr(ByVal UsbPort As Integer) As String
		Dim state As Integer
		Dim stateStr As String

		stateStr = ""

        state = PrgEnv.GetStatus(UsbPort)
		If state And GROUP_USUALLY Then
			Select Case state
				Case STATUS_USUALLY_IDLE : stateStr = "Idle"
				Case STATUS_USUALLY_PRINTING : stateStr = "Printing"
				Case STATUS_USUALLY_STANDSTILL : stateStr = "STANDSTILL"
				Case STATUS_USUALLY_PAPER_END : stateStr = "Paper End"
				Case STATUS_USUALLY_RIBBON_END : stateStr = "Ribbon End"
				Case STATUS_USUALLY_COOLING : stateStr = "Head Cooling Down"
				Case STATUS_USUALLY_MOTCOOLING : stateStr = "Motor Cooling Down"
				Case STATUS_USUALLY_STANDBY_MODE : stateStr = "Standby Mode"
			End Select
		ElseIf state And GROUP_SETTING Then
			Select Case state
				Case STATUS_SETTING_COVER_OPEN : stateStr = "Cover Open"
				Case STATUS_SETTING_PAPER_JAM : stateStr = "Paper Jam"
				Case STATUS_SETTING_RIBBON_ERR : stateStr = "Ribbon Error"
				Case STATUS_SETTING_PAPER_ERR : stateStr = "Paper definition Error"
				Case STATUS_SETTING_DATA_ERR : stateStr = "Data Error"
				Case STATUS_SETTING_SCRAPBOX_ERR : stateStr = "Scrap Box Error"
			End Select
		ElseIf state And GROUP_HARDWARE Then
			Select Case state
				Case STATUS_HARDWARE_ERR01 : stateStr = "Head Voltage Error"
				Case STATUS_HARDWARE_ERR02 : stateStr = "Head Position Error"
				Case STATUS_HARDWARE_ERR03 : stateStr = "Fan Stop Error"
				Case STATUS_HARDWARE_ERR04 : stateStr = "Cutter Error"
				Case STATUS_HARDWARE_ERR05 : stateStr = "Pinch Roller Error"
				Case STATUS_HARDWARE_ERR06 : stateStr = "Illegal Head Temperature"
				Case STATUS_HARDWARE_ERR07 : stateStr = "Illegal Media Temperature"
				Case STATUS_HARDWARE_ERR08 : stateStr = "Ribbon Tension Error"
				Case STATUS_HARDWARE_ERR09 : stateStr = "RFID Module Error"
				Case STATUS_HARDWARE_ERR10 : stateStr = "Illegal Motor Temperature"
			End Select
		ElseIf state And GROUP_SYSTEM Then
			stateStr = "SYSTEM ERROR"
		ElseIf state And GROUP_FLSHPROG Then
			stateStr = "FLSHPROG MODE"
		ElseIf state < 0 Then
			stateStr = "ERROR"
		End If

		GetStateStr = stateStr

	End Function

    '---------------------------------------------------------
    ' Get printer status
    '---------------------------------------------------------
    Function GetMediaClassStr(ByVal UsbPort As Integer) As String
        Dim s As String = New String("", 255)
        Dim i As Integer

        i = PrgEnv.GetRfidMediaClass(UsbPort, s)
        If i > 0 Then
            s = Mid(s, 1, 4)
            Select Case s
                Case "0001"
                    GetMediaClassStr = MEDIA_CLASS_NAME_RX
                Case "0002"
                    GetMediaClassStr = MEDIA_CLASS_NAME_HQL
                Case "0003"
                    GetMediaClassStr = MEDIA_CLASS_NAME_HDM
                Case Else
                    GetMediaClassStr = "Unknown"
            End Select
        Else
            GetMediaClassStr = "Unknown"
        End If

    End Function
End Module