Option Strict Off
Option Explicit On
Imports VB = Microsoft.VisualBasic
Imports System.Runtime.InteropServices

Module Cx2Sensor

	Public Function CX2_GetTempSensorInfo(ByRef headTemp As Single, ByRef mediaTemp As Single, ByRef headVolt As Single, ByRef humidity As Single) As Boolean
		Dim resStr As String

        ' Read the sensor information from the printer
		resStr = PRINTER_INFO_Sensor()

		If resStr.Length = 0 Then
			Return False
		End If

		headTemp = ExtractionTMP(resStr, 1)
		mediaTemp = ExtractionTMP(resStr, 2)
		headVolt = ExtractionHVD(resStr, 12)
		humidity = CalcHumid(resStr)

		Return True

	End Function


	Private Function ExtractionVD33(ByRef SInfo As String, ByRef n As Short) As Single
		ExtractionVD33 = ConvVoltage33(Val(Mid(SInfo, n * 9 - 4, 3)))
	End Function

	Private Function ExtractionVD50(ByRef SInfo As String, ByRef n As Short) As Single
		ExtractionVD50 = ConvVoltage50(Val(Mid(SInfo, n * 9 - 4, 3)))
	End Function

	Private Function ExtractionHVD(ByRef SInfo As String, ByRef n As Short) As Single
		ExtractionHVD = ConvHeadVoltageCV((Mid(SInfo, n * 9 - 4, 3)))
	End Function

	Private Function ExtractionTMP(ByRef SInfo As String, ByRef n As Short) As Single
		ExtractionTMP = ConvTemperature(Val(Mid(SInfo, n * 9 - 4, 3)))
	End Function

	Private Function CalcHumid(ByRef SInfo As String) As Single
        CalcHumid = ConvHumidity(Val(Mid(SInfo, 13 * 9 - 4, 3)), Val(Mid(SInfo, 1 * 9 - 4, 3)))
    End Function

	Private Function ExtractionNomal(ByRef SInfo As String, ByRef n As Short) As Single
		ExtractionNomal = Val(Mid(SInfo, n * 9 - 4, 3))
	End Function

End Module