Option Strict Off
Option Explicit On
Imports VB = Microsoft.VisualBasic
Imports System.Runtime.InteropServices

Module Cx2APIWrapper
	Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Integer)

    Public PrgEnv As Object

    Const ESC As Short = &H1BS
	Dim rb As String = New String("", 512)

	'==================================================
	'
	'
	'
	'==================================================
	Private Function SetCommandStr(ByRef s1 As String, ByRef s2 As String, ByRef ar As Integer) As String
		Dim s As String

		s = Chr(ESC) & "P" & s1.PadRight(6, " "c) & s2.PadRight(16, " "c)
		If ar < 0 Then
			SetCommandStr = s & Space(8)
		Else
			SetCommandStr = s & Format(ar, "00000000")
		End If

	End Function

	Public Function GetCommandByte( _
	   ByVal lPortNum As Integer, _
	   ByVal Cmd As String, _
	   ByVal dwCmdLen As Integer, _
	   ByRef rb() As Byte, _
	   ByVal dwRetBuffSize As Integer _
	   ) As Integer

		Dim ByteArray As Byte()
		ByteArray = System.Text.Encoding.GetEncoding(65001).GetBytes(Cmd)
		Dim gchCmd As GCHandle = GCHandle.Alloc(ByteArray, GCHandleType.Pinned)
		Dim lpCmd As Long = gchCmd.AddrOfPinnedObject().ToInt64()

        GetCommandByte = PrgEnv.CvGetCommandEX_(lPortNum, lpCmd, dwCmdLen, rb, dwRetBuffSize)

		gchCmd.Free()

	End Function

	' Sensor information
	Public Function PRINTER_INFO_Sensor() As String
		Dim s As String = New String("", 255)
		Dim ret As Long

        ret = PrgEnv.CvGetSensorInfo(sPortNo, s)
		If ret >= 0 Then
			PRINTER_INFO_Sensor = Left(s, ret)
		Else
			PRINTER_INFO_Sensor = ""
		End If

	End Function

	' Request the continuous panorama printing.
	Public Function PRINTER_CTRL_ContPanorama(ByVal continueCmd As Integer, ByVal overlapInch As Integer) As Boolean
		Dim s As String

		s = SetCommandStr("CNTRL", "CONT_PANORAMA", 8)
		s = s & continueCmd.ToString("0000") & overlapInch.ToString("0000") & Chr(&HD) & Chr(&H0)
		PRINTER_CTRL_ContPanorama = SetCommand(sPortNo, s, Len(s))

	End Function

	' Confirm able to the panorama printing.
    Public Function PRINTER_INFO_PanoramaPrint(ByRef rdata As String) As Boolean
        Dim ret As Long

        Dim S As String = SetCommandStr("INFO", "PANORAMA_PRINT", -1)
        ret = CvGetCommandEX(sPortNo, S, Len(S), rb, 512)
        rdata = rb
        If ret >= 0 Then
            If Integer.Parse(Left(rb, ret)) = 0 Then
                Return True
            End If
        End If

        Return False
    End Function

	'Get the number of media remaining.
	Public Function PRINTER_INFO_MediaRemainCount() As Integer
        Return PrgEnv.GetMediaCounter(sPortNo)
	End Function

	'Get firmware version.
	Public Function PRINTER_INFO_FirmwareVersion() As String
		Dim strVer As String = New String("", 255)

        If PrgEnv.GetFirmwVersion(sPortNo, strVer) < 0 Then
            Return "N/A"
        End If

		Return strVer
	End Function


	' Convert to code string from code number of printer status.
	Public Function Convert_APIStatusToStr(ByVal stat As Integer) As String

		If stat And CVG_USUALLY Then '================ Normal group.

			Select Case stat
				Case CVS_USUALLY_IDLE : Return "Idle"
				Case CVS_USUALLY_PRINTING : Return "Printing"
				Case CVS_USUALLY_STANDSTILL : Return "STANDSTILL"
				Case CVS_USUALLY_PAPER_END : Return "Paper End"
				Case CVS_USUALLY_RIBBON_END : Return "Ribbon End"
				Case CVS_USUALLY_COOLING : Return "Head Cooling Down"
				Case CVS_USUALLY_MOTCOOLING : Return "Motor Cooling Down"
				Case CVS_USUALLY_STANDBY_MODE : Return "Standby Mode"

			End Select

		ElseIf stat And CVG_SETTING Then  '============ Error group of status.
			Select Case stat
				Case CVS_SETTING_COVER_OPEN : Return "Cover Open"
				Case CVS_SETTING_PAPER_JAM : Return "Paper Jam"
				Case CVS_SETTING_RIBBON_ERR : Return "Ribbon Error"
				Case CVS_SETTING_PAPER_ERR : Return "Paper definition Error"
				Case CVS_SETTING_DATA_ERR : Return "Data Error"
				Case CVS_SETTING_SCRAP_ERR : Return "Scrap Box Error"
			End Select

		ElseIf stat And CVG_HARDWARE Then  '=========== Error group of heardware.

			Select Case stat
				Case CVS_HARDWARE_ERR01 : Return "Head Voltage Error"
				Case CVS_HARDWARE_ERR02 : Return "Head Position Error"
				Case CVS_HARDWARE_ERR03 : Return "Power Supply Fan Stopped"
				Case CVS_HARDWARE_ERR04 : Return "Cutter Error"
				Case CVS_HARDWARE_ERR05 : Return "Pinch Roller Position Error"
				Case CVS_HARDWARE_ERR06 : Return "Illegal Head Temperature"
				Case CVS_HARDWARE_ERR07 : Return "Illegal Media Temperature"
				Case CVS_HARDWARE_ERR08 : Return "Ribbon Tention Error"
				Case CVS_HARDWARE_ERR09 : Return "RFID Module Error"
				Case CVS_HARDWARE_ERR10 : Return "Illegal Motor Temperature"
			End Select
		ElseIf stat And CVG_SYSTEM Then	 '============= System error.

			Return "SYSTEM ERROR"

		ElseIf stat And CVG_FLSHPROG Then  '=========== Write firmware group.
			Select Case stat
				Case CVS_FLSHPROG_IDLE : Return "Flash Program Idle"
				Case CVS_FLSHPROG_WRITING : Return "Flash Program Writing"
				Case CVS_FLSHPROG_DATA_ERR1 : Return "Flash Program Data Error"
				Case CVS_FLSHPROG_DEVICE_ERR1 : Return "Flash Program Device Error"
				Case CVS_FLSHPROG_OTHERS_ERR1 : Return "Flash Program Error"
			End Select

		End If

		Return "Unknown"
	End Function

End Module