Option Strict Off
Option Explicit On
Imports System.Runtime.InteropServices
Imports System.ComponentModel


Module GetPrinterPort
	Private Const PRINTER_ATTRIBUTE_DEFAULT As Integer = &H4
    Private Const PRINTER_ATTRIBUTE_ENABLE_BIDI As Integer = &H800
    Private Const PRINTER_ATTRIBUTE_WORK_OFFLINE As Integer = &H400

    Public Function GetPortName(ByRef strPrinterDeviceName As String) As String
        Dim lngPrinterInfo5Level As Integer
        Dim lngPrinterInfo5Needed As Integer
        Dim bytPortName As Byte()
        Dim temp As Integer

        lngPrinterInfo5Level = 5

        '
        Dim hPrinter As IntPtr
        If Not OpenPrinter(strPrinterDeviceName, hPrinter, IntPtr.Zero) Then
            Throw New Win32Exception(Marshal.GetLastWin32Error())
        End If

        Dim pPrinterInfo As IntPtr = IntPtr.Zero

        Try

            '
            GetPrinter(hPrinter, lngPrinterInfo5Level, vbNullString, 0, lngPrinterInfo5Needed)
            If lngPrinterInfo5Needed <= 0 Then
                Throw New Exception("error!")
            End If
            '
            pPrinterInfo = Marshal.AllocHGlobal(lngPrinterInfo5Needed)

            '
            If Not GetPrinter(hPrinter, lngPrinterInfo5Level, pPrinterInfo, lngPrinterInfo5Needed, temp) Then
                Throw New Win32Exception(Marshal.GetLastWin32Error())
            End If

            '
            Dim printerInfo As PRINTER_INFO_5 = _
                CType(Marshal.PtrToStructure( _
                pPrinterInfo, GetType(PRINTER_INFO_5)), PRINTER_INFO_5)

            If (printerInfo.Attributes And PRINTER_ATTRIBUTE_ENABLE_BIDI) And ((printerInfo.Attributes And PRINTER_ATTRIBUTE_WORK_OFFLINE) = 0) Then
                Dim size As Integer = lstrlen(printerInfo.pPortName)

                ReDim bytPortName(size)
                Marshal.Copy(printerInfo.pPortName, bytPortName, 0, size)
                GetPortName = System.Text.Encoding.GetEncoding("Shift_JIS").GetString(bytPortName)
            Else
                GetPortName = ""
            End If

        Finally
            '
            ClosePrinter(hPrinter)
            Marshal.FreeHGlobal(pPrinterInfo)
        End Try

    End Function

End Module