Imports System.Runtime.InteropServices

Module Paper

	Public Const MediaNumMax As Integer = 32	'Number of paper size

	'Paper size information
	Structure StructPaperSize
		Dim Name As String		'size name
		Dim Number As Integer	'size number
		Dim MultiCut As Integer			' Number of multi cut.
		Dim LifeCntCoutUp As Integer	' Countup number of life counter at one printing.
	End Structure

	Public PaperSize(MediaNumMax - 1) As StructPaperSize

	Declare Function DeviceCapabilities Lib "winspool.drv" Alias "DeviceCapabilitiesA" ( _
			ByVal pDevice As String, _
			ByVal pPort As String, _
			ByVal fwCapability As Integer, _
			ByVal pOutput As IntPtr, _
			ByVal pDevMode As IntPtr) As Integer

	Declare Sub MoveMemory Lib "kernel32.dll" Alias "RtlMoveMemory" ( _
			ByVal Destination As String, _
			ByVal Source As IntPtr, _
			ByVal Length As Integer)

	Const DC_PAPERNAMES As Int32 = 16
	Const DC_PAPERS As Int32 = 2

	Public PrinterModel As Short
	Public Const PRN_6IN As Short = 0
	Public Const PRN_8IN As Short = 1

    Public PAPER_L As Integer = -1
    Public PAPER_PC As Integer = -1
    Public PAPER_2L As Integer = -1
    Public PAPER_A5 As Integer = -1
    Public PAPER_A5W As Integer = -1
    Public PAPER_8x10 As Integer = -1
    Public PAPER_8x12 As Integer = -1
    Public PAPER_A4 As Integer = -1


	'----------------------------------------------------------
	' Get paper size information
	'----------------------------------------------------------
	Public Sub GetPaperSizeInfo()
		GetPaperSizeName()		'Get paper size name
		GetPaperSizeNumber()	'Get paper size number
		MultiCutNum()			'Multi-cut number
	End Sub


	'----------------------------------------------------------
	' Get paper size name
	'----------------------------------------------------------
	Public Sub GetPaperSizeName()
		Dim strPrnName As String
		Dim strPortName As String
		Dim lngBuffSize As Integer
		Dim bytPaperName() As Byte
		Dim strTempBuffer As String
		Dim lngRetCode As Integer
		Dim n As Integer, m As Integer

        strPrnName = sPrinterName
		strPortName = GetPortName(strPrnName)

        lngBuffSize = DeviceCapabilities(strPrnName, strPortName, DC_PAPERNAMES, IntPtr.Zero, IntPtr.Zero)
        If lngBuffSize <= 0 Then
            Return
        End If

		ReDim bytPaperName(lngBuffSize * 64)

		Dim gchPn As GCHandle = GCHandle.Alloc(bytPaperName, GCHandleType.Pinned)
        Dim lpPn As Integer = gchPn.AddrOfPinnedObject().ToInt32()

        strPrnName = sPrinterName
        lngRetCode = DeviceCapabilities(strPrnName, strPortName, DC_PAPERNAMES, lpPn, IntPtr.Zero)
        If lngBuffSize <= 0 Then
            Return
        End If

        gchPn.Free()

		Dim b As Byte

		For n = 0 To lngBuffSize - 1
			strTempBuffer = ""
			For m = 0 To 64 - 1
				b = bytPaperName((n * 64) + m)
				If b = 0 Then Exit For
				strTempBuffer = strTempBuffer & CType(ChrW(b), Char)
			Next m
			PaperSize(n).Name = strTempBuffer
		Next n

	End Sub


	'----------------------------------------------------------
	' Get paper size number
	'----------------------------------------------------------
	Public Sub GetPaperSizeNumber()
		Dim strPrnName As String
		Dim strPortName As String
		Dim intOutPut() As Short
		Dim lngBuffSize As Integer
		Dim lngRetCode As Integer
		Dim n As Integer

		strPrnName = sPrinterName
		strPortName = GetPortName(strPrnName)

		lngBuffSize = DeviceCapabilities(strPrnName, strPortName, DC_PAPERS, IntPtr.Zero, IntPtr.Zero)
        If lngBuffSize <= 0 Then
            Return
        End If

		ReDim intOutPut(lngBuffSize - 1)

		Dim gchPn As GCHandle = GCHandle.Alloc(intOutPut, GCHandleType.Pinned)
        Dim lpPn As Integer = gchPn.AddrOfPinnedObject().ToInt32()

        strPrnName = sPrinterName
        lngRetCode = DeviceCapabilities(strPrnName, strPortName, DC_PAPERS, lpPn, IntPtr.Zero)
        If lngBuffSize <= 0 Then
            Return
        End If

		gchPn.Free()

		For n = 0 To lngBuffSize - 1
			PaperSize(n).Number = intOutPut(n)
		Next n

	End Sub

	Public Sub MultiCutNum()
		Dim n As Integer

		PrinterModel = PRN_6IN

        PAPER_L = -1
        PAPER_PC = -1
        PAPER_2L = -1
        PAPER_A5 = -1
        PAPER_A5W = -1
        PAPER_8x10 = -1
        PAPER_8x12 = -1
        PAPER_A4 = -1

		For n = 0 To MediaNumMax - 1

			PaperSize(n).MultiCut = 1		   'clear

			If PaperSize(n).Name IsNot Nothing Then
				If PaperSize(n).Name.IndexOf(" x 2") >= 0 Then
					PaperSize(n).MultiCut = 2
				End If
			End If

			Select Case PaperSize(n).Name

				Case "(5x3.5)"
					PAPER_L = n
					PaperSize(n).LifeCntCoutUp = 1

                Case "(6x4)"
                    PAPER_PC = n
                    PaperSize(n).LifeCntCoutUp = 1

				Case "(5x7)"
					PAPER_2L = n
					PaperSize(n).LifeCntCoutUp = 2

				Case "(6x8)"
					PAPER_A5 = n
					PaperSize(n).LifeCntCoutUp = 2

				Case "(6x9)"
					PAPER_A5W = n
					PaperSize(n).LifeCntCoutUp = 2

                Case "(8x10)"
                    PAPER_8x10 = n
                    PaperSize(n).LifeCntCoutUp = 1

                Case "(8x12)"
                    PAPER_8x12 = n
                    PaperSize(n).LifeCntCoutUp = 1

                Case "A4 Format"
                    PAPER_A4 = n
                    PaperSize(n).LifeCntCoutUp = 1

                Case Else
                    PaperSize(n).LifeCntCoutUp = 1

            End Select

		Next n

	End Sub


End Module
