#Const x64 = False
Option Strict Off
Option Explicit On
Imports System.Runtime.InteropServices

Module DS820Stat
	'
	Public Const GROUP_USUALLY As Integer = &H10000
	Public Const GROUP_SETTING As Integer = &H20000
	Public Const GROUP_HARDWARE As Integer = &H40000
	Public Const GROUP_SYSTEM As Integer = &H80000
	Public Const GROUP_FLSHPROG As Integer = &H100000

	Public Const STATUS_ERROR As Integer = &H80000000

	Public Const STATUS_USUALLY_IDLE As Integer = GROUP_USUALLY Or &H1S
	Public Const STATUS_USUALLY_PRINTING As Integer = GROUP_USUALLY Or &H2S
	Public Const STATUS_USUALLY_STANDSTILL As Integer = GROUP_USUALLY Or &H4S
	Public Const STATUS_USUALLY_PAPER_END As Integer = GROUP_USUALLY Or &H8S
	Public Const STATUS_USUALLY_RIBBON_END As Integer = GROUP_USUALLY Or &H10S
	Public Const STATUS_USUALLY_COOLING As Integer = GROUP_USUALLY Or &H20S
	Public Const STATUS_USUALLY_MOTCOOLING As Integer = GROUP_USUALLY Or &H40S
	Public Const STATUS_USUALLY_STANDBY_MODE As Integer = GROUP_USUALLY Or &H8000I

	Public Const STATUS_SETTING_COVER_OPEN As Integer = GROUP_SETTING Or &H1S
	Public Const STATUS_SETTING_PAPER_JAM As Integer = GROUP_SETTING Or &H2S
	Public Const STATUS_SETTING_RIBBON_ERR As Integer = GROUP_SETTING Or &H4S
	Public Const STATUS_SETTING_PAPER_ERR As Integer = GROUP_SETTING Or &H8S
	Public Const STATUS_SETTING_DATA_ERR As Integer = GROUP_SETTING Or &H10S
	Public Const STATUS_SETTING_SCRAPBOX_ERR As Integer = GROUP_SETTING Or &H20S

	Public Const STATUS_HARDWARE_ERR01 As Integer = GROUP_HARDWARE Or &H1S
	Public Const STATUS_HARDWARE_ERR02 As Integer = GROUP_HARDWARE Or &H2S
	Public Const STATUS_HARDWARE_ERR03 As Integer = GROUP_HARDWARE Or &H4S
	Public Const STATUS_HARDWARE_ERR04 As Integer = GROUP_HARDWARE Or &H8S
	Public Const STATUS_HARDWARE_ERR05 As Integer = GROUP_HARDWARE Or &H10S
	Public Const STATUS_HARDWARE_ERR06 As Integer = GROUP_HARDWARE Or &H20S
	Public Const STATUS_HARDWARE_ERR07 As Integer = GROUP_HARDWARE Or &H40S
	Public Const STATUS_HARDWARE_ERR08 As Integer = GROUP_HARDWARE Or &H80S
	Public Const STATUS_HARDWARE_ERR09 As Integer = GROUP_HARDWARE Or &H100S
	Public Const STATUS_HARDWARE_ERR10 As Integer = GROUP_HARDWARE Or &H200S

	Public Const STATUS_SYSTEM_ERR01 As Integer = GROUP_SYSTEM Or &H1S

	Public Const STATUS_FLSHPROG_IDLE As Integer = GROUP_FLSHPROG Or &H1S
	Public Const STATUS_FLSHPROG_WRITING As Integer = GROUP_FLSHPROG Or &H2S
	Public Const STATUS_FLSHPROG_FINISHED As Integer = GROUP_FLSHPROG Or &H4S
	Public Const STATUS_FLSHPROG_DATA_ERR1 As Integer = GROUP_FLSHPROG Or &H8S
	Public Const STATUS_FLSHPROG_DEVICE_ERR1 As Integer = GROUP_FLSHPROG Or &H10S
	Public Const STATUS_FLSHPROG_OTHERS_ERR1 As Integer = GROUP_FLSHPROG Or &H20S

	'For CV Printers Item
	Public Const CVG_USUALLY As Integer = &H10000
	Public Const CVG_SETTING As Integer = &H20000
	Public Const CVG_HARDWARE As Integer = &H40000
	Public Const CVG_SYSTEM As Integer = &H80000
	Public Const CVG_FLSHPROG As Integer = &H100000

	Public Const CVSTATUS_ERROR As Integer = &H80000000

	Public Const CVS_USUALLY_IDLE As Integer = CVG_USUALLY Or &H1S
	Public Const CVS_USUALLY_PRINTING As Integer = CVG_USUALLY Or &H2S
	Public Const CVS_USUALLY_STANDSTILL As Integer = CVG_USUALLY Or &H4S
	Public Const CVS_USUALLY_PAPER_END As Integer = CVG_USUALLY Or &H8S
	Public Const CVS_USUALLY_RIBBON_END As Integer = CVG_USUALLY Or &H10S
	Public Const CVS_USUALLY_COOLING As Integer = CVG_USUALLY Or &H20S
	Public Const CVS_USUALLY_MOTCOOLING As Integer = CVG_USUALLY Or &H40S
	Public Const CVS_USUALLY_STANDBY_MODE As Integer = CVG_USUALLY Or &H8000I

	Public Const CVS_SETTING_COVER_OPEN As Integer = CVG_SETTING Or &H1S
	Public Const CVS_SETTING_PAPER_JAM As Integer = CVG_SETTING Or &H2S
	Public Const CVS_SETTING_RIBBON_ERR As Integer = CVG_SETTING Or &H4S
	Public Const CVS_SETTING_PAPER_ERR As Integer = CVG_SETTING Or &H8S
	Public Const CVS_SETTING_DATA_ERR As Integer = CVG_SETTING Or &H10S
	Public Const CVS_SETTING_SCRAP_ERR As Integer = CVG_SETTING Or &H20S

	Public Const CVS_HARDWARE_ERR01 As Integer = CVG_HARDWARE Or &H1S
	Public Const CVS_HARDWARE_ERR02 As Integer = CVG_HARDWARE Or &H2S
	Public Const CVS_HARDWARE_ERR03 As Integer = CVG_HARDWARE Or &H4S
	Public Const CVS_HARDWARE_ERR04 As Integer = CVG_HARDWARE Or &H8S
	Public Const CVS_HARDWARE_ERR05 As Integer = CVG_HARDWARE Or &H10S
	Public Const CVS_HARDWARE_ERR06 As Integer = CVG_HARDWARE Or &H20S
	Public Const CVS_HARDWARE_ERR07 As Integer = CVG_HARDWARE Or &H40S
	Public Const CVS_HARDWARE_ERR08 As Integer = CVG_HARDWARE Or &H80S
	Public Const CVS_HARDWARE_ERR09 As Integer = CVG_HARDWARE Or &H100S
	Public Const CVS_HARDWARE_ERR10 As Integer = CVG_HARDWARE Or &H200S

	Public Const CVS_SYSTEM_ERR01 As Integer = CVG_SYSTEM Or &H1S

	Public Const CVS_FLSHPROG_IDLE As Integer = CVG_FLSHPROG Or &H1S
	Public Const CVS_FLSHPROG_WRITING As Integer = CVG_FLSHPROG Or &H2S
	Public Const CVS_FLSHPROG_FINISHED As Integer = CVG_FLSHPROG Or &H4S
	Public Const CVS_FLSHPROG_DATA_ERR1 As Integer = CVG_FLSHPROG Or &H8S
	Public Const CVS_FLSHPROG_DEVICE_ERR1 As Integer = CVG_FLSHPROG Or &H10S
	Public Const CVS_FLSHPROG_OTHERS_ERR1 As Integer = CVG_FLSHPROG Or &H20S

	' Cutter Mode
	Public Const CUTTER_MODE_STANDARD As Short = 0
	Public Const CUTTER_MODE_NONSCRAP As Short = 1
	Public Const CUTTER_MODE_2INCHCUT As Short = 120
	Public Const CUTTER_MODE_PANORAMA As Short = 1000

	' return value of GetPanoramaPrintable()
	Public Const STATUS_PRINTABLE As Integer = &H0
	Public Const STATUS_HIGHTEMP_HEAD As Integer = &H1
	Public Const STATUS_HIGHTEMP_BOTH As Integer = &H11
	Public Const STATUS_HIGHHUMIDITY As Integer = &H100
	Public Const STATUS_LOWTEMP_MEDIA As Integer = &H20
	Public Const STATUS_OTHER_STATE As Integer = &H10000
	Public Const STATUS_COMM_ERROR As Integer = (-1)

	' Overcoat Finish
	Public Const OVERCOAT_FINISH_GLOSSY As Integer = 0
	Public Const OVERCOAT_FINISH_MATTE1 As Integer = 1
	Public Const OVERCOAT_FINISH_MATTE2 As Integer = 2
	Public Const OVERCOAT_FINISH_MATTE3 As Integer = 3
	Public Const OVERCOAT_FINISH_FINEMATTE As Integer = 21
	Public Const OVERCOAT_FINISH_LUSTER As Integer = 22
	Public Const OVERCOAT_FINISH_HSMATTE As Integer = 31
	Public Const OVERCOAT_FINISH_PMATTE11 As Integer = 101
	Public Const OVERCOAT_FINISH_PMATTE12 As Integer = 121
	Public Const OVERCOAT_FINISH_PMATTE13 As Integer = 122

	' Print Speed
	Public Const PRINTSPEED_NORMAL As Integer = 0
	Public Const PRINTSPEED_HIGH_DENSITY As Integer = 3

	' Media type
	Public Const MEDIA_RX As Integer = 1
	Public Const MEDIA_HDM As Integer = 3

#If x64 Then
	Declare Function CvInitialize Lib "DS820Stat64.dll" (<MarshalAs(UnmanagedType.LPWStr)> ByVal pszPortName As String) As Integer
	Declare Function CvGetVersion Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal s As String) As Integer
	Declare Function CvGetSensorInfo Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal s As String) As Integer
	Declare Function CvGetMedia Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal s As String) As Integer
	Declare Function CvGetStatus Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function CvGetPQTY Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function CvGetCounterL Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function CvGetCounterA Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function CvGetCounterB Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function CvGetMediaCounter Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function CvGetMediaColorOffset Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function CvGetMediaLotNo Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal s As String) As Integer
	Declare Function CvSetColorDataVersion_ Lib "DS820Stat64.dll" Alias "CvSetColorDataVersion" (ByVal lPortNum As Integer, ByVal lpBuff As Integer, ByVal bLen As Integer) As Integer
	Declare Function CvSetColorDataWrite_ Lib "DS820Stat64.dll" Alias "CvSetColorDataWrite" (ByVal lPortNum As Integer, ByVal lpBuff As Integer, ByVal bLen As Integer) As Integer
	Declare Function CvGetColorDataVersion Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal s As String) As Integer
	Declare Function CvSetColorDataClear Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function CvGetColorDataChecksum Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal s As String) As Integer
	Declare Function CvGetSerialNo Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal s As String) As Integer
	Declare Function CvGetResolutionH Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function CvGetResolutionV Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function CvGetFreeBuffer Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function CvSetClearCounterA Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function CvSetClearCounterB Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function CvSetFirmwUpdateMode Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function CvSetFirmwDataWrite_ Lib "DS820Stat64.dll" Alias "CvSetFirmwDataWrite" (ByVal lPortNum As Integer, ByVal lpBuff As Integer, ByVal bLen As Integer) As Integer
	Declare Function CvSetCommand_ Lib "DS820Stat64.dll" Alias "CvSetCommand" (ByVal lPortNum As Integer, ByVal lpCmd As Integer, ByVal dwCmdLen As Integer) As Integer
	Declare Function CvGetCommand_ Lib "DS820Stat64.dll" Alias "CvGetCommand" (ByVal lPortNum As Integer, ByVal lpCmd As Integer, ByVal dwCmdLen As Integer, ByVal lpRetBuff As String, ByVal dwRetBuffSize As Integer, ByRef lpdwRetLen As Integer) As Integer
	Declare Function CvGetCommandEX_ Lib "DS820Stat64.dll" Alias "CvGetCommandEX" (ByVal lPortNum As Integer, ByVal lpCmd As Integer, ByVal dwCmdLen As Integer, ByVal lpRetBuff As String, ByVal dwRetBuffSize As Integer) As Integer
	Declare Function CvGetCommandEX_ Lib "DS820Stat64.dll" Alias "CvGetCommandEX" (ByVal lPortNum As Integer, ByVal lpCmd As Integer, ByVal dwCmdLen As Integer, ByVal lpRetBuff() As Byte, ByVal dwRetBuffSize As Integer) As Integer
	'
	Declare Function PortInitialize Lib "DS820Stat64.dll" (<MarshalAs(UnmanagedType.LPWStr)> ByVal pszPortName As String) As Integer
	Declare Function PortInitializeEX Lib "DS820Stat64.dll" (<MarshalAs(UnmanagedType.LPWStr)> ByVal pszPortName As String, <MarshalAs(UnmanagedType.LPWStr)> ByVal pszPrinterName As String) As Integer
	Declare Function RegisterPrinterName Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, <MarshalAs(UnmanagedType.LPWStr)> ByVal pszPrinterName As String) As Integer
	Declare Function GetFirmwVersion Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal s As String) As Integer
	Declare Function GetSensorInfo Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal s As String) As Integer
	Declare Function GetMedia Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal s As String) As Integer
	Declare Function GetStatus Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function GetPQTY Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function GetCounterL Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function GetCounterA Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function GetCounterB Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function GetCounterP Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function GetCounterMatte Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function GetCounterM Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function GetMediaCounter Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function GetMediaCounterH Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function GetMediaColorOffset Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function GetMediaLotNo Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal s As String) As Integer
	Declare Function GetRfidMediaClass Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal s As String) As Integer
	Declare Function GetRfidReserveData Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal s As String, ByVal dwPAge As Integer) As Integer
	Declare Function SetColorDataVersion_ Lib "DS820Stat64.dll" Alias "SetColorDataVersion" (ByVal lPortNum As Integer, ByVal lpBuff As Integer, ByVal bLen As Integer) As Integer
	Declare Function SetColorDataWrite_ Lib "DS820Stat64.dll" Alias "SetColorDataWrite" (ByVal lPortNum As Integer, ByVal lpBuff As Integer, ByVal bLen As Integer) As Integer
	Declare Function GetColorDataVersion Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal s As String) As Integer
	Declare Function GetColorDataVersionRes Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal s As String, ByVal dpi As Integer) As Integer
	Declare Function SetColorDataClear Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function GetColorDataChecksum Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal s As String) As Integer
	Declare Function GetColorDataChecksumRes Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal s As String, ByVal dpi As Integer) As Integer
	Declare Function GetSerialNo Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal s As String) As Integer
	Declare Function GetResolutionH Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function GetResolutionV Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function GetFreeBuffer Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function SetClearCounterA Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function SetClearCounterB Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function SetClearCounterM Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function SetCounterP Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal Counter As Integer) As Integer
	Declare Function SetFirmwUpdateMode Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function SetFirmwDataWrite_ Lib "DS820Stat64.dll" Alias "SetFirmwDataWrite" (ByVal lPortNum As Integer, ByVal lpBuff As Integer, ByVal bLen As Integer) As Integer
	Declare Function SetCutterMode Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal d As Integer) As Integer
	Declare Function GetInitialMediaCount Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function SetUSBSerialEnable Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal b As Boolean) As Integer
	Declare Function GetUSBSerialEnable Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer

	Declare Function SetFullCutterSetup Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal lSize1 As Integer, ByVal lSize2 As Integer, ByVal lSize3 As Integer, ByVal lSize4 As Integer, ByVal lSize5 As Integer, ByVal lSize6 As Integer) As <MarshalAs(UnmanagedType.Bool)> Boolean
	Declare Function SetStandbyTime Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal lTime As Integer) As <MarshalAs(UnmanagedType.Bool)> Boolean
	Declare Function GetStandbyTime Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function SetEndKeepMode Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal lMode As Integer) As <MarshalAs(UnmanagedType.Bool)> Boolean
	Declare Function GetEndKeepMode Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function SetFullCutterSetupEX Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal lCutSize1 As Integer, ByVal lCutSize2 As Integer, ByVal lCutSize3 As Integer, ByVal lCutSize4 As Integer, ByVal lCutSize5 As Integer, ByVal lCutSize6 As Integer, ByVal DustSize As Integer) As <MarshalAs(UnmanagedType.Bool)> Boolean
	Declare Function GetPanoramaPrintable Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function SetOvercoatFinish Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal ovcoat As Integer) As <MarshalAs(UnmanagedType.Bool)> Boolean
	Declare Function GetColorDataVersionResEX Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal s As String, ByVal dpi As Integer, ByVal lMedia As Integer) As Integer
	Declare Function GetColorDataChecksumResEX Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal s As String, ByVal dpi As Integer, ByVal lMedia As Integer) As Integer
	Declare Function SetPrintSpeed Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal lPrintSpeed As Integer) As <MarshalAs(UnmanagedType.Bool)> Boolean

	Declare Function SetGammaTable Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal lpGammaTable() As Byte, ByVal lDataLen As Integer) As <MarshalAs(UnmanagedType.Bool)> Boolean
	Declare Function GetGammaTableChecksum Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal s As String) As Integer
	Declare Function SetDataTableClear Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As <MarshalAs(UnmanagedType.Bool)> Boolean

	Declare Function SetContPanorama Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal dwContinuous As UInteger, ByVal dwOverlap As UInteger) As <MarshalAs(UnmanagedType.Bool)> Boolean

#Else
	Declare Function CvInitialize Lib "DS820Stat.dll" (<MarshalAs(UnmanagedType.LPWStr)> ByVal pszPortName As String) As Integer
	Declare Function CvGetVersion Lib "DS820Stat.dll" (ByVal lPortNum As Integer, ByVal s As String) As Integer
	Declare Function CvGetSensorInfo Lib "DS820Stat.dll" (ByVal lPortNum As Integer, ByVal s As String) As Integer
	Declare Function CvGetMedia Lib "DS820Stat.dll" (ByVal lPortNum As Integer, ByVal s As String) As Integer
	Declare Function CvGetStatus Lib "DS820Stat.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function CvGetPQTY Lib "DS820Stat.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function CvGetCounterL Lib "DS820Stat.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function CvGetCounterA Lib "DS820Stat.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function CvGetCounterB Lib "DS820Stat.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function CvGetMediaCounter Lib "DS820Stat.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function CvGetMediaColorOffset Lib "DS820Stat.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function CvGetMediaLotNo Lib "DS820Stat.dll" (ByVal lPortNum As Integer, ByVal s As String) As Integer
	Declare Function CvSetColorDataVersion_ Lib "DS820Stat.dll" Alias "CvSetColorDataVersion" (ByVal lPortNum As Integer, ByVal lpBuff As Integer, ByVal bLen As Integer) As Integer
	Declare Function CvSetColorDataWrite_ Lib "DS820Stat.dll" Alias "CvSetColorDataWrite" (ByVal lPortNum As Integer, ByVal lpBuff As Integer, ByVal bLen As Integer) As Integer
	Declare Function CvGetColorDataVersion Lib "DS820Stat.dll" (ByVal lPortNum As Integer, ByVal s As String) As Integer
	Declare Function CvSetColorDataClear Lib "DS820Stat.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function CvGetColorDataChecksum Lib "DS820Stat.dll" (ByVal lPortNum As Integer, ByVal s As String) As Integer
	Declare Function CvGetSerialNo Lib "DS820Stat.dll" (ByVal lPortNum As Integer, ByVal s As String) As Integer
	Declare Function CvGetResolutionH Lib "DS820Stat.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function CvGetResolutionV Lib "DS820Stat.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function CvGetFreeBuffer Lib "DS820Stat.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function CvSetClearCounterA Lib "DS820Stat.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function CvSetClearCounterB Lib "DS820Stat.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function CvSetFirmwUpdateMode Lib "DS820Stat.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function CvSetFirmwDataWrite_ Lib "DS820Stat.dll" Alias "CvSetFirmwDataWrite" (ByVal lPortNum As Integer, ByVal lpBuff As Integer, ByVal bLen As Integer) As Integer
	Declare Function CvSetCommand_ Lib "DS820Stat.dll" Alias "CvSetCommand" (ByVal lPortNum As Integer, ByVal lpCmd As Integer, ByVal dwCmdLen As Integer) As Integer
	Declare Function CvGetCommand_ Lib "DS820Stat.dll" Alias "CvGetCommand" (ByVal lPortNum As Integer, ByVal lpCmd As Integer, ByVal dwCmdLen As Integer, ByVal lpRetBuff As String, ByVal dwRetBuffSize As Integer, ByRef lpdwRetLen As Integer) As Integer
	Declare Function CvGetCommandEX_ Lib "DS820Stat.dll" Alias "CvGetCommandEX" (ByVal lPortNum As Integer, ByVal lpCmd As Integer, ByVal dwCmdLen As Integer, ByVal lpRetBuff As String, ByVal dwRetBuffSize As Integer) As Integer
	Declare Function CvGetCommandEX_ Lib "DS820Stat.dll" Alias "CvGetCommandEX" (ByVal lPortNum As Integer, ByVal lpCmd As Integer, ByVal dwCmdLen As Integer, ByVal lpRetBuff() As Byte, ByVal dwRetBuffSize As Integer) As Integer
	'
	Declare Function PortInitialize Lib "DS820Stat.dll" (<MarshalAs(UnmanagedType.LPWStr)> ByVal pszPortName As String) As Integer
	Declare Function PortInitializeEX Lib "DS820Stat.dll" (<MarshalAs(UnmanagedType.LPWStr)> ByVal pszPortName As String, <MarshalAs(UnmanagedType.LPWStr)> ByVal pszPrinterName As String) As Integer
	Declare Function RegisterPrinterName Lib "DS820Stat.dll" (ByVal lPortNum As Integer, <MarshalAs(UnmanagedType.LPWStr)> ByVal pszPrinterName As String) As Integer
	Declare Function GetFirmwVersion Lib "DS820Stat.dll" (ByVal lPortNum As Integer, ByVal s As String) As Integer
	Declare Function GetSensorInfo Lib "DS820Stat.dll" (ByVal lPortNum As Integer, ByVal s As String) As Integer
	Declare Function GetMedia Lib "DS820Stat.dll" (ByVal lPortNum As Integer, ByVal s As String) As Integer
	Declare Function GetStatus Lib "DS820Stat.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function GetPQTY Lib "DS820Stat.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function GetCounterL Lib "DS820Stat.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function GetCounterA Lib "DS820Stat.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function GetCounterB Lib "DS820Stat.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function GetCounterP Lib "DS820Stat.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function GetCounterMatte Lib "DS820Stat.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function GetCounterM Lib "DS820Stat.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function GetMediaCounter Lib "DS820Stat.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function GetMediaCounter_R Lib "DS820Stat.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function GetMediaCounterH Lib "DS820Stat.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function GetMediaCounterH_R Lib "DS820Stat.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function GetMediaColorOffset Lib "DS820Stat.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function GetMediaLotNo Lib "DS820Stat.dll" (ByVal lPortNum As Integer, ByVal s As String) As Integer
	Declare Function GetMediaIdSetInfo Lib "DS820Stat.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function GetRfidMediaClass Lib "DS820Stat.dll" (ByVal lPortNum As Integer, ByVal s As String) As Integer
	Declare Function GetRfidReserveData Lib "DS820Stat.dll" (ByVal lPortNum As Integer, ByVal s As String, ByVal dwPAge As Integer) As Integer
	Declare Function SetColorDataVersion_ Lib "DS820Stat.dll" Alias "SetColorDataVersion" (ByVal lPortNum As Integer, ByVal lpBuff As Integer, ByVal bLen As Integer) As Integer
	Declare Function SetColorDataWrite_ Lib "DS820Stat.dll" Alias "SetColorDataWrite" (ByVal lPortNum As Integer, ByVal lpBuff As Integer, ByVal bLen As Integer) As Integer
	Declare Function GetColorDataVersion Lib "DS820Stat.dll" (ByVal lPortNum As Integer, ByVal s As String) As Integer
	Declare Function GetColorDataVersionRes Lib "DS820Stat.dll" (ByVal lPortNum As Integer, ByVal s As String, ByVal dpi As Integer) As Integer
	Declare Function SetColorDataClear Lib "DS820Stat.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function GetColorDataChecksum Lib "DS820Stat.dll" (ByVal lPortNum As Integer, ByVal s As String) As Integer
	Declare Function GetColorDataChecksumRes Lib "DS820Stat.dll" (ByVal lPortNum As Integer, ByVal s As String, ByVal dpi As Integer) As Integer
	Declare Function GetSerialNo Lib "DS820Stat.dll" (ByVal lPortNum As Integer, ByVal s As String) As Integer
	Declare Function GetResolutionH Lib "DS820Stat.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function GetResolutionV Lib "DS820Stat.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function GetFreeBuffer Lib "DS820Stat.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function SetClearCounterA Lib "DS820Stat.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function SetClearCounterB Lib "DS820Stat.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function SetClearCounterM Lib "DS820Stat.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function SetCounterP Lib "DS820Stat.dll" (ByVal lPortNum As Integer, ByVal Counter As Integer) As Integer
	Declare Function SetFirmwUpdateMode Lib "DS820Stat.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function SetFirmwDataWrite_ Lib "DS820Stat.dll" Alias "SetFirmwDataWrite" (ByVal lPortNum As Integer, ByVal lpBuff As Integer, ByVal bLen As Integer) As Integer
	Declare Function SetCutterMode Lib "DS820Stat.dll" (ByVal lPortNum As Integer, ByVal d As Integer) As Integer
	Declare Function GetInitialMediaCount Lib "DS820Stat.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function SetUSBSerialEnable Lib "DS820Stat.dll" (ByVal lPortNum As Integer, ByVal b As Boolean) As Integer
	Declare Function GetUSBSerialEnable Lib "DS820Stat.dll" (ByVal lPortNum As Integer) As Integer

	Declare Function SetFullCutterSetup Lib "DS820Stat.dll" (ByVal lPortNum As Integer, ByVal lSize1 As Integer, ByVal lSize2 As Integer, ByVal lSize3 As Integer, ByVal lSize4 As Integer, ByVal lSize5 As Integer, ByVal lSize6 As Integer) As <MarshalAs(UnmanagedType.Bool)> Boolean
	Declare Function SetStandbyTime Lib "DS820Stat.dll" (ByVal lPortNum As Integer, ByVal lTime As Integer) As <MarshalAs(UnmanagedType.Bool)> Boolean
	Declare Function GetStandbyTime Lib "DS820Stat.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function SetEndKeepMode Lib "DS820Stat.dll" (ByVal lPortNum As Integer, ByVal lMode As Integer) As <MarshalAs(UnmanagedType.Bool)> Boolean
	Declare Function GetEndKeepMode Lib "DS820Stat.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function SetFullCutterSetupEX Lib "DS820Stat.dll" (ByVal lPortNum As Integer, ByVal lCutSize1 As Integer, ByVal lCutSize2 As Integer, ByVal lCutSize3 As Integer, ByVal lCutSize4 As Integer, ByVal lCutSize5 As Integer, ByVal lCutSize6 As Integer, ByVal DustSize As Integer) As <MarshalAs(UnmanagedType.Bool)> Boolean
	Declare Function GetPanoramaPrintable Lib "DS820Stat.dll" (ByVal lPortNum As Integer) As Integer
	Declare Function SetOvercoatFinish Lib "DS820Stat.dll" (ByVal lPortNum As Integer, ByVal ovcoat As Integer) As <MarshalAs(UnmanagedType.Bool)> Boolean
	Declare Function GetColorDataVersionResEX Lib "DS820Stat.dll" (ByVal lPortNum As Integer, ByVal s As String, ByVal dpi As Integer, ByVal lMedia As Integer) As Integer
	Declare Function GetColorDataChecksumResEX Lib "DS820Stat.dll" (ByVal lPortNum As Integer, ByVal s As String, ByVal dpi As Integer, ByVal lMedia As Integer) As Integer
	Declare Function SetPrintSpeed Lib "DS820Stat.dll" (ByVal lPortNum As Integer, ByVal lPrintSpeed As Integer) As <MarshalAs(UnmanagedType.Bool)> Boolean

	Declare Function SetGammaTable Lib "DS820Stat.dll" (ByVal lPortNum As Integer, ByVal lpGammaTable() As Byte, ByVal lDataLen As Integer) As <MarshalAs(UnmanagedType.Bool)> Boolean
	Declare Function GetGammaTableChecksum Lib "DS820Stat.dll" (ByVal lPortNum As Integer, ByVal s As String) As Integer
	Declare Function SetDataTableClear Lib "DS820Stat.dll" (ByVal lPortNum As Integer) As <MarshalAs(UnmanagedType.Bool)> Boolean

	Declare Function SetContPanorama Lib "DS820Stat.dll" (ByVal lPortNum As Integer, ByVal dwContinuous As UInteger, ByVal dwOverlap As UInteger) As <MarshalAs(UnmanagedType.Bool)> Boolean


#End If

	'-----------------------------------------------------------------------------------CX API Wrapper function
	Public Function CvSetCommand( _
	  ByVal lPortNum As Integer, _
	  ByVal Cmd As String, _
	  ByVal dwCmdLen As Integer _
	  ) As Integer

		Dim ByteArray As Byte()
		'Code Page 65001 = UTF-8
		ByteArray = System.Text.Encoding.GetEncoding(65001).GetBytes(Cmd)
		'Kx[WRN^Œ肷
		Dim gchCmd As GCHandle = GCHandle.Alloc(ByteArray, GCHandleType.Pinned)
		'ŒIuWFNg̃AhX擾
		Dim lpCmd As Integer = gchCmd.AddrOfPinnedObject().ToInt32()
		CvSetCommand = CvSetCommand_(lPortNum, lpCmd, dwCmdLen)

		'J
		gchCmd.Free()

	End Function

	Public Function CvSetData( _
	  ByVal lPortNum As Integer, _
	  ByVal ByteArray() As Byte, _
	  ByVal dwLen As Integer _
	  ) As Integer

		Dim gchCmd As GCHandle = GCHandle.Alloc(ByteArray, GCHandleType.Pinned)
		Dim lpCmd As Integer = gchCmd.AddrOfPinnedObject().ToInt32()
		CvSetData = CvSetCommand_(lPortNum, lpCmd, dwLen)

		gchCmd.Free()

	End Function


	Public Function CvGetCommand( _
	 ByVal lPortNum As Integer, _
	 ByVal Cmd As String, _
	 ByVal dwCmdLen As Integer, _
	 ByRef rb As String, _
	 ByVal dwRetBuffSize As Integer, _
	 ByRef dwRetLen As Integer _
	 ) As Integer

		Dim ByteArray As Byte()
		ByteArray = System.Text.Encoding.GetEncoding(65001).GetBytes(Cmd)
		Dim gchCmd As GCHandle = GCHandle.Alloc(ByteArray, GCHandleType.Pinned)
		Dim gchRetLen As GCHandle = GCHandle.Alloc(dwRetLen, GCHandleType.Pinned)
		Dim lpCmd As Integer = gchCmd.AddrOfPinnedObject().ToInt32()
		Dim lpdwRetLen As Integer = gchCmd.AddrOfPinnedObject().ToInt32()
		CvGetCommand = CvGetCommand_(lPortNum, lpCmd, dwCmdLen, rb, dwRetBuffSize, lpdwRetLen)

		gchCmd.Free()
		gchRetLen.Free()

	End Function

	Public Function CvGetCommandEX( _
	   ByVal lPortNum As Integer, _
	   ByVal Cmd As String, _
	   ByVal dwCmdLen As Integer, _
	   ByRef rb As String, _
	   ByVal dwRetBuffSize As Integer _
	   ) As Integer

		Dim ByteArray As Byte()
		ByteArray = System.Text.Encoding.GetEncoding(65001).GetBytes(Cmd)
		Dim gchCmd As GCHandle = GCHandle.Alloc(ByteArray, GCHandleType.Pinned)
		Dim lpCmd As Integer = gchCmd.AddrOfPinnedObject().ToInt32()
		CvGetCommandEX = CvGetCommandEX_(lPortNum, lpCmd, dwCmdLen, rb, dwRetBuffSize)

		gchCmd.Free()

	End Function

	Public Function SetCommand( _
	   ByVal lPortNum As Integer, _
	   ByVal Cmd As String, _
	   ByVal dwCmdLen As Integer _
	   ) As Integer
		SetCommand = CvSetCommand(lPortNum, Cmd, dwCmdLen)

	End Function

	Public Function GetCommand( _
	   ByVal lPortNum As Integer, _
	   ByVal Cmd As String, _
	   ByVal dwCmdLen As Integer, _
	   ByRef rb As String, _
	   ByVal dwRetBuffSize As Integer, _
	   ByRef dwRetLen As Integer _
	   ) As Integer
		GetCommand = CvGetCommand(lPortNum, Cmd, dwCmdLen, rb, dwRetBuffSize, dwRetLen)

	End Function

	Public Function GetCommandEX( _
	  ByVal lPortNum As Integer, _
	  ByVal Cmd As String, _
	  ByVal dwCmdLen As Integer, _
	  ByRef rb As String, _
	  ByVal dwRetBuffSize As Integer _
	  ) As Integer

		GetCommandEX = CvGetCommandEX(lPortNum, Cmd, dwCmdLen, rb, dwRetBuffSize)

	End Function

	Public Function SetFirmwDataWrite( _
	  ByVal lPortNum As Integer, _
	  ByVal ByteArray() As Byte, _
	  ByVal dwLen As Integer _
	  ) As Integer

		Dim gchCmd As GCHandle = GCHandle.Alloc(ByteArray, GCHandleType.Pinned)
		Dim lpCmd As Integer = gchCmd.AddrOfPinnedObject().ToInt32()
		SetFirmwDataWrite = SetFirmwDataWrite_(lPortNum, lpCmd, dwLen)

		gchCmd.Free()

	End Function

	Public Function CvSetFirmwDataWrite( _
	  ByVal lPortNum As Integer, _
	  ByVal ByteArray() As Byte, _
	  ByVal dwLen As Integer _
	  ) As Integer

		CvSetFirmwDataWrite = SetFirmwDataWrite(lPortNum, ByteArray, dwLen)

	End Function


	Public Function CvSetColorDataVersion( _
	  ByVal lPortNum As Integer, _
	  ByVal Cmd As String, _
	  ByVal dwCmdLen As Integer _
	  ) As Integer

		Dim ByteArray As Byte()
		ByteArray = System.Text.Encoding.GetEncoding(65001).GetBytes(Cmd)
		Dim gchCmd As GCHandle = GCHandle.Alloc(ByteArray, GCHandleType.Pinned)
		Dim lpCmd As Integer = gchCmd.AddrOfPinnedObject().ToInt32()
		CvSetColorDataVersion = CvSetColorDataVersion_(lPortNum, lpCmd, dwCmdLen)

		gchCmd.Free()

	End Function

	Public Function SetColorDataVersion( _
	  ByVal lPortNum As Integer, _
	  ByVal Cmd As String, _
	  ByVal dwCmdLen As Integer _
	  ) As Integer

		SetColorDataVersion = CvSetColorDataVersion(lPortNum, Cmd, dwCmdLen)
	End Function

	Public Function CvSetColorDataWrite( _
	  ByVal lPortNum As Integer, _
	  ByVal ByteArray() As Byte, _
	  ByVal dwLen As Integer _
	  ) As Integer

		Dim gchCmd As GCHandle = GCHandle.Alloc(ByteArray, GCHandleType.Pinned)
		Dim lpCmd As Integer = gchCmd.AddrOfPinnedObject().ToInt32()
		CvSetColorDataWrite = CvSetColorDataWrite_(lPortNum, lpCmd, dwLen)

		gchCmd.Free()

	End Function

	Public Function SetColorDataWrite( _
	  ByVal lPortNum As Integer, _
	  ByVal ByteArray() As Byte, _
	  ByVal dwLen As Integer _
	  ) As Integer

		SetColorDataWrite = CvSetColorDataWrite(lPortNum, ByteArray, dwLen)
	End Function

End Module

