Option Strict Off
Option Explicit On
Imports VB = Microsoft.VisualBasic
Imports System.Runtime.InteropServices

Friend Class Form1
    Inherits System.Windows.Forms.Form

    Const ESC As Short = &H1BS

    Private PortName As String                  'USB port name
    Private PortNo As Integer                   'Port number

    Public PrnSet As PRINT_SETTING
	Public PAPER_SIZE_8x12 As Integer


    '==================================================
    ' Form Load
    '==================================================
    Private Sub Form1_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load

        '-----------------------------------------
        'File Path / File Name / Printer Name
        '-----------------------------------------
		PrinterName = "DP-DS820"		'Printer Name

        '-----------------------------------------
        'Get port name
        '-----------------------------------------
        PortName = GetPortName(PrinterName)
        If PortName = "" Then
            MsgBox("Printer(" & PrinterName & ") is not connected. ", MsgBoxStyle.OkOnly)
            End
        End If
        PortNo = PortInitialize(PortName) 'Initialize of Status API

        PrintSettingIni()

    End Sub

    '---------------------------------------------------------
    'Print Setting Ini
    '---------------------------------------------------------
    Public Sub PrintSettingIni()

		'Get index of (8x12) paper size.
		PAPER_SIZE_8x12 = getPaperID("(8x12)")

		ExDevModeTopSearch()
		SetPrintSettingInfo()

    End Sub


    '---------------------------------------------------------
    'Devmode Ini
    '---------------------------------------------------------
    Public Sub SetPrintSettingInfo()
		PrnSet.PaperSize = PAPER_SIZE_8x12
        PrnSet.Orientation = DM_ORIENT_PORTRAIT
        PrnSet.PrintQuality = 300
        PrnSet.YResolution = 300
        PrnSet.ICMMethod = DM_ICMMETHOD_SYSTEM
        PrnSet.Border = DM_BORDER_OFF
        PrnSet.Sharpness = 2
        PrnSet.ColorAdjustment = DM_EXCOLORADJ_NONE
        PrnSet.AdjGammaR = 0
        PrnSet.AdjGammaG = 0
        PrnSet.AdjGammaB = 0
        PrnSet.AdjBrightnessR = 0
        PrnSet.AdjBrightnessG = 0
        PrnSet.AdjBrightnessB = 0
        PrnSet.AdjContrastR = 0
        PrnSet.AdjContrastG = 0
        PrnSet.AdjContrastB = 0
        PrnSet.AdjChromaR = 0
        PrnSet.AdjChromaG = 0
        PrnSet.AdjChromaB = 0
        PrnSet.OvercoatFinish = DM_OVERCOAT_GLOSSY
        PrnSet.PrintRetry = DM_PRN_RETRY_OFF
		PrnSet.Cut2inch = DM_CUT2INCH_OFF
		PrnSet.HighDensity = DM_HIGHDENSITY_OFF

	End Sub


    '==================================================
    ' Exsample 1
    '==================================================
    Private Sub cmdSet1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdSet1.Click

        ' Update the FullCutterSetup setting by Status API.
		If SetFullCutterSetup(PortNo, CInt(txtImageSize1_1.Text), CInt(txtImageSize1_2.Text), CInt(txtImageSize1_3.Text), CInt(txtImageSize1_4.Text), CInt(txtImageSize1_5.Text), CInt(txtImageSize1_6.Text)) = False Then
			MsgBox("Set FullCutterSetup failed.")
		End If

    End Sub

    '==================================================
    ' Exsample 2
    '==================================================
    Private Sub cmdSet2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdSet2.Click

        ' Update the FullCutterSetup setting by Status API.
		If SetFullCutterSetup(PortNo, CInt(txtImageSize2_1.Text), CInt(txtImageSize2_2.Text), CInt(txtImageSize2_3.Text), CInt(txtImageSize2_4.Text), CInt(txtImageSize2_5.Text), CInt(txtImageSize2_6.Text)) = False Then
			MsgBox("Set FullCutterSetup failed.")
		End If

    End Sub

    '==================================================
    ' Free setting (SetFullCutterSetup)
    '==================================================
    Private Sub cmdSet3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdSet3.Click

        ' Update the FullCutterSetup setting by Status API.
		If SetFullCutterSetup(PortNo, CInt(txtImageSize3_1.Text), CInt(txtImageSize3_2.Text), CInt(txtImageSize3_3.Text), CInt(txtImageSize3_4.Text), CInt(txtImageSize3_5.Text), CInt(txtImageSize3_6.Text)) = False Then
			MsgBox("Set FullCutterSetup failed.")
		End If

    End Sub

    '==================================================
    ' Free setting (SetFullCutterSetupEx)
    '==================================================
    Private Sub cmdSet4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdSet4.Click

        ' Update the FullCutterSetup setting by Status API.
		If SetFullCutterSetupEX(PortNo, CInt(txtImageSize4_1.Text), CInt(txtImageSize4_2.Text), CInt(txtImageSize4_3.Text), CInt(txtImageSize4_4.Text), CInt(txtImageSize4_5.Text), CInt(txtImageSize4_6.Text), CInt(txtImageSize4_scrap.Text)) = False Then
			MsgBox("Set FullCutterSetupEX failed.")
		End If

    End Sub

    '==================================================
    'Print
    '==================================================
    Private Sub cmdPrint1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdPrint1.Click
        pd.PrinterSettings.PrinterName = PrinterName
		PrnSet.PaperSize = PAPER_SIZE_8x12
        PrintSetting(PrnSet, pd)

		Try
			pd.Print()
		Catch ex As Exception
			' error message
			MessageBox.Show(ex.Message)
		End Try

	End Sub

    '==================================================
    'PrintPage Handler
    '==================================================
    Private Sub pd_PrintPage(ByVal sender As Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs) Handles pd.PrintPage
        Dim PrtFont As New Font("Arial", 36)
        e.Graphics.DrawString("TEST PRINT", PrtFont, Brushes.Black, 150, 80)
    End Sub
End Class