Public Class Form1
	' Gray Balance - default
	Const GRAY_BALANCE_DEFAULT As String = "F6(Standard)"
	Const GRAY_BALANCE_CENTER As String = "btnF6"

	' BackColor Value
	Const COLOR_SELECTED As Integer = &H7F00FFFF
	Const COLOR_MOUSEOVER As Integer = &H7F7F7F7F
	Const COLOR_DEFAULT As Integer = &H00000000

	' Data Table define
	Const PACK_SIZE As Integer = 4
	Const TABLE_COLUMN As Integer = 4
	Const TABLE_HEADER_SIZE As Integer = 8
	Const TABLE_BODY_OFFSET As Integer = TABLE_HEADER_SIZE
	Const TABLE_DATA_SIZE As Integer = 8000

	Const DATA_DIR As String = "data"

	' About Test Chart Printing
	Const FILE_TEST_CHART As String = "TestChart8x5.bmp"
	Private PortName As String					'USB port name
	Private PortNo As Integer					'Port number
	Private PrnSet As PRINT_SETTING
	Private PAPER_SIZE_8x5 As Integer
	Private PrintImage As Image

	' support version
	Const VER_NUM_UPPER As Integer = 0 
	Const VER_NUM_LOWER As Integer = 50 

	'----------------------------------------------------------------------------------
	' Form Load
	'----------------------------------------------------------------------------------

	Private Sub Form1_Load( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles MyBase.Load

		setMouseOverBackColor()
		btnPrintTestChart.Focus()
		btnF6.BackColor = Color.FromArgb(COLOR_SELECTED)
		txtSelectedValue.Text = GRAY_BALANCE_DEFAULT

		getPortNum()

	End Sub

	Private Sub setMouseOverBackColor()
		Dim c As Control
		For Each c In pnlChartImage.Controls
			CType(c, Button).FlatAppearance.MouseOverBackColor = Color.FromArgb(COLOR_MOUSEOVER)
		Next
	End Sub

	Private Sub getPortNum()
		PrinterName = "DP-DS820"		'Printer Name

		PortName = GetPortName(PrinterName)
		If PortName = "" Then
			MsgBox("Printer(" & PrinterName & ") is not connected. ", MsgBoxStyle.OkOnly)
			End
		End If
		PortNo = PortInitialize(PortName) 'Initialize of Status API

		checkVersion()

		PrintSettingIni()

	End Sub

	' Check Firmware Version
	Private Sub checkVersion()
		Dim iRet As Integer
		Dim s As String = New String("", 256)
		Dim versionName As String
		Dim verUpper As Integer
		Dim verLower As Integer

		iRet = GetFirmwVersion(PortNo, s)
		If iRet < 0 Then
			MsgBox("Printer is not responding. ", MsgBoxStyle.OkOnly)
			End
		End If

		versionName = s.Substring(0, iRet)

		If versionName.Contains("DS820 ") Or versionName.Contains("DS820A ") Then
			iRet = versionName.IndexOf(".")
			If iRet < 2 Then
				' specific version (no check)
			Else
				verUpper = Val(versionName.Substring(iRet - 2, 2))
				verLower = Val(versionName.Substring(iRet + 1, 2))
				If (verUpper > VER_NUM_UPPER) Or _
				   (verUpper = VER_NUM_UPPER And verLower >= VER_NUM_LOWER) Then
					' support version
				Else
					' not support version
					MsgBox("Printer does not support this feature. Supported by firmware version 00.50 or later.", MsgBoxStyle.OkOnly)
					End
				End If
			End If
		Else
			' specific version (no check)
		End If

	End Sub

	Private Sub PrintSettingIni()
		Dim i As Integer

		GetPaperSizeInfo()

		'Get index of (8x10) paper size.
		For i = 0 To PaperSize.Length - 1
			If PaperSize(i).Name = "(8x5)" Then
				PAPER_SIZE_8x5 = PaperSize(i).Number
				Exit For
			End If
		Next

		ExDevModeTopSearch()
		SetPrintSettingInfo()

	End Sub

	' Devmode Initialize
	Private Sub SetPrintSettingInfo()
		PrnSet.PaperSize = PAPER_SIZE_8x5
		PrnSet.Orientation = DM_ORIENT_PORTRAIT
		PrnSet.PrintQuality = 300
		PrnSet.YResolution = 300
		PrnSet.ICMMethod = DM_ICMMETHOD_SYSTEM
		PrnSet.Border = DM_BORDER_OFF
		PrnSet.Sharpness = 2
		PrnSet.ColorAdjustment = DM_EXCOLORADJ_NONE
		PrnSet.AdjGammaR = 0
		PrnSet.AdjGammaG = 0
		PrnSet.AdjGammaB = 0
		PrnSet.AdjBrightnessR = 0
		PrnSet.AdjBrightnessG = 0
		PrnSet.AdjBrightnessB = 0
		PrnSet.AdjContrastR = 0
		PrnSet.AdjContrastG = 0
		PrnSet.AdjContrastB = 0
		PrnSet.AdjChromaR = 0
		PrnSet.AdjChromaG = 0
		PrnSet.AdjChromaB = 0
		PrnSet.OvercoatFinish = DM_OVERCOAT_GLOSSY
		PrnSet.PrintRetry = DM_PRN_RETRY_OFF
		PrnSet.Cut2inch = DM_CUT2INCH_OFF
		PrnSet.HighDensity = DM_HIGHDENSITY_OFF
	End Sub

	'----------------------------------------------------------------------------------
	' Event - Print Test Chart
	'----------------------------------------------------------------------------------

	Private Sub btnPrintTestChart_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles btnPrintTestChart.Click
		changeControlState(False)

		printTestChart()

		changeControlState(True)
	End Sub

	'----------------------------------------------------------------------------------
	' Event - Send Data Table
	'----------------------------------------------------------------------------------

	Private Sub btnSendDataTable_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles btnSendDataTable.Click
		changeControlState(False)

		CMD_SetGummaTable()

		changeControlState(True)
	End Sub

	'----------------------------------------------------------------------------------
	' Event - Gray Balance Setting
	'----------------------------------------------------------------------------------

	Private Sub grayBalanceButton_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) _
	  Handles btnA1.Click, btnA2.Click, btnA3.Click, btnA4.Click, btnA5.Click, btnA6.Click _
			, btnB1.Click, btnB2.Click, btnB3.Click, btnB4.Click, btnB5.Click, btnB6.Click, btnB7.Click _
			, btnC1.Click, btnC2.Click, btnC3.Click, btnC4.Click, btnC5.Click, btnC6.Click, btnC7.Click, btnC8.Click _
			, btnD1.Click, btnD2.Click, btnD3.Click, btnD4.Click, btnD5.Click, btnD6.Click, btnD7.Click, btnD8.Click, btnD9.Click _
			, btnE1.Click, btnE2.Click, btnE3.Click, btnE4.Click, btnE5.Click, btnE6.Click, btnE7.Click, btnE8.Click, btnE9.Click, btnE10.Click _
			, btnF1.Click, btnF2.Click, btnF3.Click, btnF4.Click, btnF5.Click, btnF6.Click, btnF7.Click, btnF8.Click, btnF9.Click, btnF10.Click, btnF11.Click _
			, btnG1.Click, btnG2.Click, btnG3.Click, btnG4.Click, btnG5.Click, btnG6.Click, btnG7.Click, btnG8.Click, btnG9.Click, btnG10.Click _
			, btnH1.Click, btnH2.Click, btnH3.Click, btnH4.Click, btnH5.Click, btnH6.Click, btnH7.Click, btnH8.Click, btnH9.Click _
			, btnI1.Click, btnI2.Click, btnI3.Click, btnI4.Click, btnI5.Click, btnI6.Click, btnI7.Click, btnI8.Click _
			, btnJ1.Click, btnJ2.Click, btnJ3.Click, btnJ4.Click, btnJ5.Click, btnJ6.Click, btnJ7.Click _
			, btnK1.Click, btnK2.Click, btnK3.Click, btnK4.Click, btnK5.Click, btnK6.Click
		changeSelectedValue()
	End Sub

	'----------------------------------------------------------------------------------
	' Event - PrintPage
	'----------------------------------------------------------------------------------

	Private Sub pd_PrintPage(ByVal sender As Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs) Handles pd.PrintPage
		Dim Ratio As Single
		Dim Print_Width As Single
		Dim Print_Height As Single

		Ratio = e.PageBounds.Height / PrintImage.Height
		Print_Width = PrintImage.Width * Ratio
		Print_Height = PrintImage.Height * Ratio


		If Print_Width < e.PageBounds.Width Then
			Ratio = e.PageBounds.Width / PrintImage.Width
			Print_Width = PrintImage.Width * Ratio
			Print_Height = PrintImage.Height * Ratio
		End If

		'Centering
		Dim OverWidth As Single = e.PageBounds.Width - Print_Width
		Dim OverHeight As Single = e.PageBounds.Height - Print_Height
		Dim imgTop As Single = OverWidth / 2
		Dim imgLeft As Single = OverHeight / 2

		e.Graphics.DrawImage(PrintImage, imgTop, imgLeft, Print_Width, Print_Height)

		e.HasMorePages = False
	End Sub

	'----------------------------------------------------------------------------------
	' Function - Print Tesst Chart
	'----------------------------------------------------------------------------------

	Private Sub printTestChart()
		Dim bRet As Boolean
		Dim filePath As String = String.Empty

		bRet = SetDataTableClear(PortNo)
		If bRet = False Then
			MsgBox("Failed to SetDataTableClear().", MsgBoxStyle.OkOnly Or MsgBoxStyle.SystemModal)
			Exit Sub
		End If

		pd.PrinterSettings.PrinterName = PrinterName
		PrnSet.PaperSize = PAPER_SIZE_8x5
		PrintSetting(PrnSet, pd)

		'Read image file
		bRet = getFilePath(FILE_TEST_CHART, DATA_DIR, filePath)
		If bRet = False Then
			MsgBox(FILE_TEST_CHART & " file not found.", MsgBoxStyle.OkOnly Or MsgBoxStyle.SystemModal)
			Exit Sub
		End If

		PrintImage = System.Drawing.Image.FromFile(filePath)

		'Print image data is transmitted
		Try
			pd.Print()
		Catch ex As Exception
			' error message
			MessageBox.Show(ex.Message)
		Finally
			If PrintImage IsNot Nothing Then
				PrintImage.Dispose()
			End If
		End Try

	End Sub

	'----------------------------------------------------------------------------------
	' Function - Send Data Table
	'----------------------------------------------------------------------------------

	Private Sub CMD_SetGummaTable()
		Dim bRet As Boolean
		Dim dataSize As Integer
		Dim dataTable(TABLE_DATA_SIZE) As Byte
		Dim dataFileName As String = String.Empty
		Dim iRet As Integer
		Dim chkSum As String = New String(vbNullString, 256)
		Dim sendSum As UInt16

		dataFileName = getDataFileName()
		If dataFileName = String.Empty Then
			MsgBox("Data file not found.", MsgBoxStyle.OkOnly Or MsgBoxStyle.SystemModal)
		End If

		bRet = convertCsvToBin(dataFileName, True, dataTable, dataSize)
		If dataSize <> dataTable.Length Then
			MsgBox("Failed to read data file.", MsgBoxStyle.OkOnly Or MsgBoxStyle.SystemModal)
		End If

		bRet = SetGammaTable(PortNo, dataTable, dataTable.Length)
		If bRet = False Then
			MsgBox("Failed to SetGammaTable()", MsgBoxStyle.OkOnly Or MsgBoxStyle.SystemModal)
		End If

		iRet = GetGammaTableChecksum(PortNo, chkSum)
		If iRet < 0 Then
			MsgBox("Failed to GetGammaTableChecksum()", MsgBoxStyle.OkOnly Or MsgBoxStyle.SystemModal)
		Else
			sendSum = Convert_byteToUint16(dataTable, 6, 2, True)
			If chkSum.Substring(0, iRet) <> sendSum.ToString("X4") Then
				MsgBox("Checksum value did not match.", MsgBoxStyle.OkOnly Or MsgBoxStyle.SystemModal)
			End If
		End If

	End Sub

	Private Function getDataFileName() As String
		Dim fileName As String
		If txtSelectedValue.Text = GRAY_BALANCE_DEFAULT Then
			fileName = "F6.csv"
		Else
			fileName = txtSelectedValue.Text & ".csv"
		End If

		Return fileName

	End Function

	Private Function convertCsvToBin(ByVal cweFileName As String, ByVal bBigEndian As Boolean, ByRef byteArray As Byte(), ByRef dataLength As Integer) As Boolean
		Dim defDir As String
		Dim filePath As String
		Dim cweData As System.Collections.ArrayList
		Dim countLine As Integer
		Dim offset As Integer
		Dim chkSum As UInt32
		Dim i As Integer
		Dim j As Integer
		Dim tempData() As Byte
		Dim lineData() As String

		'get file path
		defDir = DATA_DIR
		filePath = ""

		If getFilePath(cweFileName, defDir, filePath) = False Then
			Return False
		End If

		'read data table
		cweData = New System.Collections.ArrayList()

		If readCSVFile(filePath, countLine, cweData) = False Then
			Return False
		End If

		If countLine > 0 Then
			ReDim byteArray(TABLE_HEADER_SIZE + 2 * (countLine * TABLE_COLUMN) - 1)
		End If
		Array.Clear(byteArray, 0, byteArray.Length)

		offset = TABLE_BODY_OFFSET

		'extention data
		lineData = cweData.Item(0)
		For i = 0 To lineData.Length - 1
			tempData = BitConverter.GetBytes(CUShort(lineData(i)))
			assignData(byteArray, offset, tempData, bBigEndian)
		Next
		'correction data
		For i = 0 To TABLE_COLUMN - 1
			For j = 1 To countLine - 1
				lineData = cweData.Item(j)
				If lineData.Length < i Then
					Continue For
				End If
				tempData = BitConverter.GetBytes(CUShort(lineData(i)))
				assignData(byteArray, offset, tempData, bBigEndian)
			Next
		Next
		dataLength = offset
		'Header part(Unit Size)
		offset = 0
		tempData = BitConverter.GetBytes(CUShort(2))
		assignData(byteArray, offset, tempData, bBigEndian)

		'Header part(Row Count)
		tempData = BitConverter.GetBytes(CUShort(countLine - 1))
		assignData(byteArray, offset, tempData, bBigEndian)

		'Header part(Plane)
		tempData = BitConverter.GetBytes(CUShort(TABLE_COLUMN))
		assignData(byteArray, offset, tempData, bBigEndian)

		'Header part(Check Sum)
		chkSum = 0
		For i = TABLE_BODY_OFFSET To dataLength - 1
			chkSum += CUShort(byteArray(i))
		Next
		tempData = BitConverter.GetBytes(CUShort((&HFFFFUI And chkSum)))
		assignData(byteArray, offset, tempData, bBigEndian)

		Return True

	End Function

	'----------------------------------------------------------------------------------
	' Event - Gray Balance Setting
	'----------------------------------------------------------------------------------

	Private Sub changeSelectedValue()
		changeBackColor()
		Update()
		Refresh()
	End Sub

	Private Sub changeBackColor()
		Dim c As Control
		For Each c In pnlChartImage.Controls
			If c.Focused Then
				c.BackColor = Color.FromArgb(COLOR_SELECTED)
				If c.Name = GRAY_BALANCE_CENTER Then
					txtSelectedValue.Text = GRAY_BALANCE_DEFAULT
				Else
					txtSelectedValue.Text = c.Name.Substring(3, c.Name.Length-3)
				End If
			Else
				c.BackColor = Color.FromArgb(COLOR_DEFAULT)
			End If
		Next
	End Sub

	'----------------------------------------------------------------------------------
	' Function - Other
	'----------------------------------------------------------------------------------

	Private Sub changeControlState(ByVal bEnable As Boolean)
		btnPrintTestChart.Enabled = bEnable
		btnSendDataTable.Enabled = bEnable
		txtSelectedValue.Enabled = bEnable
		pnlChartImage.Enabled = bEnable
	End Sub

End Class
