Option Strict Off
Option Explicit On
Imports System.Runtime.InteropServices

Friend Class Form1
	Inherits System.Windows.Forms.Form

	Private Const NUM_OF_IMAGES As Integer = 3	'Number of image files

	Private PortName As String					'USB port name
	Private PortNo As Integer					'Port number
	Private FileName(NUM_OF_IMAGES) As String	'Imege file name
	Private HasMore As Integer					'Multi cut
	Private PrnCount As Integer					'Printing counter
	Private PrnSet As PRINT_SETTING				'Structure of print setting
	Private MediaCode As Integer				'Ribbon media code

	'-----------------------------------------
	'Setting value and text in ComboBox
	'-----------------------------------------
	Public Structure ComboItem
		Public Text As String
		Public Number As Integer
		Public Overrides Function ToString() As String
			Return Text
		End Function
		Public Sub New(ByVal S As String, ByVal I As Integer)
			Text = S
			Number = I
		End Sub
	End Structure


	'*******************************************************
	'
	'	Form Load
	'
	'
	'*******************************************************
	Private Sub Form1_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
		Dim n As Integer

		'-----------------------------------------
		'File Path / File Name / Printer Name
		'-----------------------------------------
		FileName(0) = "01.jpg"		'Imege File(PATH/NAME)
		FileName(1) = "02.jpg"		'
		FileName(2) = "03.jpg"		'

		PrinterName = "DP-DS820"		'Printer Name

		'-----------------------------------------
		'Get port name
		'-----------------------------------------
		PortName = GetPortName(PrinterName)
		If PortName = "" Then
			MsgBox("Printer(" & PrinterName & ") is not connected. ", MsgBoxStyle.OkOnly)
			End
		End If
		PortNo = PortInitialize(PortName) 'Initialize of Status API

		'-----------------------------------------
		'Display of printer name and port name
		'-----------------------------------------
		txtPrinterName.Text = PrinterName
		txtPortName.Text = PortName

		'-----------------------------------------
		'Setting of PaperSize combo box
		'-----------------------------------------
		GetPaperSizeInfo()
		For n = 0 To MediaNumMax
			If PaperSize(n).Name <> "" Then
				ComboPaperSize.Items.Add( _
				   New ComboItem(PaperSize(n).Name, _
				   PaperSize(n).Number))
			Else
				Exit For
			End If
		Next n
		ComboPaperSize.SelectedIndex = 0

		'-----------------------------------------
		'Setting of Orientation combo box
		'-----------------------------------------
		With ComboOrientation
			.Items.Add(New ComboItem("PORTRAIT", DM_ORIENT_PORTRAIT))
			.Items.Add(New ComboItem("LANDSCAPE", DM_ORIENT_LANDSCAPE))
			.SelectedIndex = 0
		End With

		'-----------------------------------------
		'Setting of Border combo box
		'-----------------------------------------
		With ComboBorder
			.Items.Add(New ComboItem("OFF", DM_BORDER_OFF))
			.Items.Add(New ComboItem("ON", DM_BORDER_ON))
			.SelectedIndex = 0
		End With

		'-----------------------------------------
		'Setting of Sharpness combo box
		'-----------------------------------------
		With ComboSharpness
			.Items.Add(New ComboItem("-2 (Blur)", 0))
			.Items.Add(New ComboItem("-1", 1))
			.Items.Add(New ComboItem("0 (Default)", 2))
			.Items.Add(New ComboItem("1", 3))
			.Items.Add(New ComboItem("2", 4))
			.Items.Add(New ComboItem("3", 5))
			.Items.Add(New ComboItem("4", 6))
			.Items.Add(New ComboItem("5", 7))
			.Items.Add(New ComboItem("6", 8))
			.Items.Add(New ComboItem("7", 9))
			.Items.Add(New ComboItem("8 (Hard)", 10))
			.SelectedIndex = 2
		End With

		'-----------------------------------------
		'Setting of High Density combo box
		'-----------------------------------------
		With ComboHighDensityPrint
			.Items.Add(New ComboItem("OFF", DM_HIGHDENSITY_OFF))
			.Items.Add(New ComboItem("ON", DM_HIGHDENSITY_ON))
			.SelectedIndex = 0
		End With

		'-----------------------------------------
		'Setting of PrintQuality combo box
		'-----------------------------------------
		With ComboPrintQuality
			.Items.Add(New ComboItem("300x300dpi", QUALITY_300x300))
			.Items.Add(New ComboItem("300x600dpi", QUALITY_300x600))
			.Items.Add(New ComboItem("600x600dpi", QUALITY_600x600))
			.SelectedIndex = 0
		End With

		'-----------------------------------------
		'Setting of OvercoatFinish combo box
		'-----------------------------------------
		With ComboOvercoatFinish
			.Items.Add(New ComboItem("Glossy", DM_OVERCOAT_GLOSSY))
			.Items.Add(New ComboItem("Matte", DM_OVERCOAT_MATTE))
			.Items.Add(New ComboItem("Fine-matte", DM_OVERCOAT_FINEMATTE))
			.Items.Add(New ComboItem("Luster", DM_OVERCOAT_LUSTER))
			.SelectedIndex = 0
		End With

		'-----------------------------------------
		'Setting of PrintRetry combo box
		'-----------------------------------------
		With ComboPrintRetry
			.Items.Add(New ComboItem("OFF", DM_PRN_RETRY_OFF))
			.Items.Add(New ComboItem("ON", DM_PRN_RETRY_ON))
			.SelectedIndex = 0
		End With

		'-----------------------------------------
		'Initializing of Quantity
		'-----------------------------------------
		NumericQuantity.Value = 1

		'-----------------------------------------
		'Setting of ICM combo box
		'-----------------------------------------
		With ComboICM
			.Items.Add(New ComboItem("OFF", DM_ICMMETHOD_NONE))
			.Items.Add(New ComboItem("ON", DM_ICMMETHOD_SYSTEM))
			.SelectedIndex = 0
		End With

		'-----------------------------------------
		'Setting of ColorAdjustment combo box
		'-----------------------------------------
		With ComboColorAdjustment
			.Items.Add(New ComboItem("OFF", DM_EXCOLORADJ_NONE))
			.Items.Add(New ComboItem("ON", DM_EXCOLORADJ_DRIVER))
			.SelectedIndex = 0
		End With

		'-----------------------------------------
		'Initializing of ColorAdjustment
		'-----------------------------------------
		TextBoxGamma.Text = 0
		TextBoxBrightness.Text = 0
		TextBoxContrast.Text = 0
		TextBoxChroma.Text = 0

		'-----------------------------------------
		'Searches for top of the private DevMode
		'-----------------------------------------
		ExDevModeTopSearch()

		Timer1.Enabled = True
	End Sub

	'*******************************************************
	'
	'	Form Closing
	'
	'
	'*******************************************************
	Private Sub Form1_FormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
		If Image1.Image IsNot Nothing Then
			Image1.Image.Dispose()
		End If
	End Sub

	'*******************************************************
	'
	'	Print
	'
	'
	'*******************************************************
	Private Sub ButtonPrint_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles ButtonPrint.Click

		Timer1.Enabled = False

		pd.PrinterSettings.PrinterName = PrinterName

		ButtonPrint.Enabled = False

		'-------------------------------------------
		'Get user setting
		'-------------------------------------------
		'Paper Size
		PrnSet.PaperSize = DirectCast(ComboPaperSize.SelectedItem, ComboItem).Number

		'Orientation
		PrnSet.Orientation = DirectCast(ComboOrientation.SelectedItem, ComboItem).Number
		Dim n As Integer = DirectCast(ComboPrintQuality.SelectedItem, ComboItem).Number

		'Print Quality
		If n = QUALITY_300x300 Then
			PrnSet.PrintQuality = 300
			PrnSet.YResolution = 300
		ElseIf n = QUALITY_300x600 Then
			PrnSet.PrintQuality = 300
			PrnSet.YResolution = 600
		Else
			PrnSet.PrintQuality = 600
			PrnSet.YResolution = 600
		End If

		'Border
		PrnSet.Border = DirectCast(ComboBorder.SelectedItem, ComboItem).Number

		'Sharpness
		PrnSet.Sharpness = DirectCast(ComboSharpness.SelectedItem, ComboItem).Number

		'ICM
		PrnSet.ICMMethod = DirectCast(ComboICM.SelectedItem, ComboItem).Number

		'Color Adjustment
		PrnSet.ColorAdjustment = DirectCast(ComboColorAdjustment.SelectedItem, ComboItem).Number
		'Gamma
		PrnSet.AdjGammaR = Val(TextBoxGamma.Text)
		PrnSet.AdjGammaG = Val(TextBoxGamma.Text)
		PrnSet.AdjGammaG = Val(TextBoxGamma.Text)
		'Brightness
		PrnSet.AdjBrightnessR = Val(TextBoxBrightness.Text)
		PrnSet.AdjBrightnessG = Val(TextBoxBrightness.Text)
		PrnSet.AdjBrightnessB = Val(TextBoxBrightness.Text)
		'Contrast
		PrnSet.AdjContrastR = Val(TextBoxContrast.Text)
		PrnSet.AdjContrastG = Val(TextBoxContrast.Text)
		PrnSet.AdjContrastB = Val(TextBoxContrast.Text)
		'Chroma
		PrnSet.AdjChromaR = Val(TextBoxChroma.Text)
		PrnSet.AdjChromaG = Val(TextBoxChroma.Text)
		PrnSet.AdjChromaB = Val(TextBoxChroma.Text)

		'Overcoat Finish (Glossy/Mattej
		PrnSet.OvercoatFinish = DirectCast(ComboOvercoatFinish.SelectedItem, ComboItem).Number

		'Print Re-try
		PrnSet.PrintRetry = DirectCast(ComboPrintRetry.SelectedItem, ComboItem).Number

		'2inch Cut
		PrnSet.Cut2inch = 0

		'High Density
		PrnSet.HighDensity = DirectCast(ComboHighDensityPrint.SelectedItem, ComboItem).Number

		'-----------------------------------------
		'Print setting
		'-----------------------------------------
		PrintSetting(PrnSet, pd)
		HasMore = NumericQuantity.Value

		PrnCount = 0

		'-----------------------------------------
		'Print
		'-----------------------------------------
		Try
			pd.Print()
		Catch ex As Exception
			' error message
			MessageBox.Show(ex.Message)
		End Try

		Timer1.Enabled = True

	End Sub

	'-----------------------------------------
	'PrintPage Handler
	'-----------------------------------------
	Private Sub pd_PrintPage(ByVal sender As Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs) Handles pd.PrintPage
		Dim img As Image = Image1.Image.Clone
		Dim Ratio As Single = e.PageBounds.Height / img.Height
		Dim Print_Width As Single = img.Width * Ratio
		Dim Print_Height As Single = img.Height * Ratio

		If Print_Width < e.PageBounds.Width Then
			Ratio = e.PageBounds.Width / img.Width
			Print_Width = img.Width * Ratio
			Print_Height = img.Height * Ratio
		End If

		'Centering
		Dim OverWidth As Single = e.PageBounds.Width - Print_Width
		Dim OverHeight As Single = e.PageBounds.Height - Print_Height
		Dim imgTop As Single = OverWidth / 2
		Dim imgLeft As Single = OverHeight / 2

		e.Graphics.DrawImage(img, imgTop, imgLeft, Print_Width, Print_Height)

		HasMore = HasMore - 1
		e.HasMorePages = (HasMore > 0)
		PrnCount += 1

		If HasMore <= 0 Then
			ButtonPrint.Enabled = True
		End If

		img.Dispose()

	End Sub

	Protected Sub pd_QueryPageSettings(ByVal sender As Object, ByVal e As QueryPageSettingsEventArgs) Handles pd.QueryPageSettings
		File_Open(FileName(PrnCount Mod NUM_OF_IMAGES))
	End Sub

	'*******************************************************
	'
	'	Others
	'
	'
	'*******************************************************
	'-----------------------------------------
	'Get printer information
	'-----------------------------------------
	Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
		Dim media_counter As Integer

		'check the job of the print queue
		If CheckPrnJob(PrinterName) = True Then
			Exit Sub
		End If

		'Printer status
		txtPrinterStatus.Text = GetStateStr(PortNo)

		'Media counter
		media_counter = GetMediaCounter(PortNo)
		If media_counter < 0 Then media_counter = 0
		txtMediaCounter.Text = Str(media_counter)

		'Media half size counter
		media_counter = GetMediaCounterH(PortNo)
		If media_counter < 0 Then media_counter = 0
		txtMediaCounterH.Text = Str(media_counter)

		'Life counter
		txtLifeCounter.Text = Str(GetCounterL(PortNo))
	End Sub

	'-----------------------------------------
	'Open image file
	'-----------------------------------------
	Private Sub File_Open(ByVal FileName As String)
		On Error GoTo File_Open_Err
		Dim ratio As Single
		Dim OverWidth As Single
		Dim OverHeight As Single

		'Dispose previously allocated image data.
		If Me.Image1.Image IsNot Nothing Then
			Me.Image1.Image.Dispose()
		End If

		Me.Image1.Image = System.Drawing.Image.FromFile(FileName)

		'Display size adjustment
		Me.Image1.Width = Panel1.Width
		ratio = Panel1.Width / Me.Image1.Image.Width
		Me.Image1.Height = Me.Image1.Image.Height * ratio
		If Me.Image1.Height > Panel1.Height Then
			Me.Image1.Height = Panel1.Height
			ratio = Panel1.Height / Me.Image1.Image.Height
			Me.Image1.Width = Me.Image1.Image.Width * ratio
		End If

		'Centering
		OverWidth = Panel1.Height - Me.Image1.Height
		OverHeight = Panel1.Width - Me.Image1.Width
		Me.Image1.Top = OverWidth / 2
		Me.Image1.Left = OverHeight / 2

		Me.Show()
		System.Windows.Forms.Application.DoEvents()
		Exit Sub

File_Open_Err:
		MsgBox("File not found : " & FileName)
		End
	End Sub

	'-----------------------------------------
	' Click ColorAdjustment combo box
	'-----------------------------------------
	Private Sub ComboColorAdjustment_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboColorAdjustment.SelectedIndexChanged
		If DirectCast(ComboColorAdjustment.SelectedItem, ComboItem).Number = DM_EXCOLORADJ_DRIVER Then
			TextBoxGamma.Enabled = True
			TextBoxBrightness.Enabled = True
			TextBoxContrast.Enabled = True
			TextBoxChroma.Enabled = True
		Else
			TextBoxGamma.Enabled = False
			TextBoxBrightness.Enabled = False
			TextBoxContrast.Enabled = False
			TextBoxChroma.Enabled = False
		End If
	End Sub

	'-----------------------------------------
	'Setting of upper bound and lower bound
	'-----------------------------------------
	Private Sub TextBoxGamma_LostFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBoxGamma.LostFocus
		TextBoxGamma.Text = Val(TextBoxGamma.Text)
		If Val(TextBoxGamma.Text) > 100 Then
			TextBoxGamma.Text = 100
		ElseIf Val(TextBoxGamma.Text) < -100 Then
			TextBoxGamma.Text = -100
		End If
	End Sub

	Private Sub TextBoxBrightness_LostFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBoxBrightness.LostFocus
		TextBoxBrightness.Text = Val(TextBoxBrightness.Text)
		If Val(TextBoxBrightness.Text) > 100 Then
			TextBoxBrightness.Text = 100
		ElseIf Val(TextBoxBrightness.Text) < -100 Then
			TextBoxBrightness.Text = -100
		End If
	End Sub

	Private Sub TextBoxContrast_LostFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBoxContrast.LostFocus
		TextBoxContrast.Text = Val(TextBoxContrast.Text)
		If Val(TextBoxContrast.Text) > 100 Then
			TextBoxContrast.Text = 100
		ElseIf Val(TextBoxContrast.Text) < -100 Then
			TextBoxContrast.Text = -100
		End If
	End Sub

	Private Sub TextBoxChroma_LostFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBoxChroma.LostFocus
		TextBoxChroma.Text = Val(TextBoxChroma.Text)
		If Val(TextBoxChroma.Text) > 100 Then
			TextBoxChroma.Text = 100
		ElseIf Val(TextBoxChroma.Text) < -100 Then
			TextBoxChroma.Text = -100
		End If
	End Sub

	'-----------------------------------------
	' Click Print Quality combo box
	'-----------------------------------------
	Private Sub ComboPaperSize_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboPrintQuality.SelectedIndexChanged
		If DirectCast(ComboPrintQuality.SelectedItem, ComboItem).Number = QUALITY_600x600 Then
			ComboHighDensityPrint.Enabled = True
		Else
			ComboHighDensityPrint.Enabled = False
			ComboHighDensityPrint.SelectedIndex = 0	'DM_HIGHDENSITY_OFF
		End If
	End Sub

End Class