Option Strict Off
Option Explicit On
Imports VB = Microsoft.VisualBasic

Friend Class Form1
	Inherits System.Windows.Forms.Form
	' =====================================================
	'
    '   .Net VB Status API Sample Program
	'
	'
	' =====================================================
	
	Private DS820 As Integer

	Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim PrinterName As String
        Dim PortName As String

		PrinterName = "DP-DS820"		'Printer Name

        '********************* InitializeiSelect Port Numberj
        PortName = GetPortName(PrinterName)
        If PortName = "" Then
            MsgBox("Printer(" & PrinterName & ") is not connected. ", MsgBoxStyle.OkOnly)
            End
        End If
		DS820 = PortInitialize(PortName) 'Initialize of Status API
		If DS820 < 0 Then MsgBox("Error!", vbOKOnly) : End

	End Sub

    '********************* Get version infomation
	Private Sub btnGetFirmVersion_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetFirmVersion.Click
		Dim s As String = New String("", 255)
		Dim l As Integer

		TextBox_Result.Text = "GetFirmwVersion() value: "

		l = GetFirmwVersion(DS820, s)
		If l >= 0 Then TextBox_Result.Text += VB.Left(s, l) Else TextBox_Result.Text += "ERROR!"

	End Sub

	'********************* Get sensor information
	Private Sub btnGetSensorInfo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetSensorInfo.Click
		Dim s As String = New String("", 255)
		Dim l As Integer

		TextBox_Result.Text = "GetSensorInfo() value: "

		l = GetSensorInfo(DS820, s)
		If l >= 0 Then TextBox_Result.Text += VB.Left(s, l) Else TextBox_Result.Text += "ERROR!"

	End Sub

	'********************* Get resolution H
	Private Sub btnGetResolutionH_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetResolutionH.Click
		Dim c As Integer

		TextBox_Result.Text = "GetResolutionH() value: "

		c = GetResolutionH(DS820)
		If c >= 0 Then TextBox_Result.Text += Str(c) Else TextBox_Result.Text += "ERROR!"

	End Sub

	'********************* Get resolution V
	Private Sub btnGetResolutionV_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetResolutionV.Click
		Dim c As Integer

		TextBox_Result.Text = "GetResolutionV() value: "

		c = GetResolutionV(DS820)
		If c >= 0 Then TextBox_Result.Text += Str(c) Else TextBox_Result.Text += "ERROR!"

	End Sub

	'********************* Get media code
	Private Sub btnGetMedia_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetMedia.Click
		Dim s As String = New String("", 255)
		Dim l As Integer

		TextBox_Result.Text = "GetMedia() value: "

		l = GetMedia(DS820, s)
		If l >= 0 Then TextBox_Result.Text += VB.Left(s, l) Else TextBox_Result.Text += "ERROR!"

	End Sub

	'********************* Printer status
	Private Sub btnGetStatus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetStatus.Click
		Dim stat As Integer

		TextBox_Result.Text = "GetStatus() value: "

		stat = GetStatus(DS820)

		If stat = STATUS_ERROR Then
			TextBox_Result.Text += "ERROR!"
			Exit Sub
		End If


		If stat And GROUP_USUALLY Then '================ Usually status group.

			Select Case stat
				Case STATUS_USUALLY_IDLE : TextBox_Result.Text += "Idle"
				Case STATUS_USUALLY_PRINTING : TextBox_Result.Text += "Printing"
				Case STATUS_USUALLY_STANDSTILL : TextBox_Result.Text += "STANDSTILL"
				Case STATUS_USUALLY_PAPER_END : TextBox_Result.Text += "Paper End"
				Case STATUS_USUALLY_RIBBON_END : TextBox_Result.Text += "Ribbon End"
				Case STATUS_USUALLY_COOLING : TextBox_Result.Text += "Head Cooling Down"
				Case STATUS_USUALLY_MOTCOOLING : TextBox_Result.Text += "Motor Cooling Down"
				Case STATUS_USUALLY_STANDBY_MODE : TextBox_Result.Text += "Standby Mode"
			End Select

		ElseIf stat And GROUP_SETTING Then	'============ Printer setting status group.

			Select Case stat
				Case STATUS_SETTING_COVER_OPEN : TextBox_Result.Text += "Cover Open"
				Case STATUS_SETTING_PAPER_JAM : TextBox_Result.Text += "Paper Jam"
				Case STATUS_SETTING_RIBBON_ERR : TextBox_Result.Text += "Ribbon Error"
				Case STATUS_SETTING_PAPER_ERR : TextBox_Result.Text += "Paper definition Error"
				Case STATUS_SETTING_DATA_ERR : TextBox_Result.Text += "Data Error"
				Case STATUS_SETTING_SCRAPBOX_ERR : TextBox_Result.Text += "Scrap Box Error"
			End Select

		ElseIf stat And GROUP_HARDWARE Then	 '=========== Hardware erro status group.

			Select Case stat
				Case STATUS_HARDWARE_ERR01 : TextBox_Result.Text += "Head Voltage Error"
				Case STATUS_HARDWARE_ERR02 : TextBox_Result.Text += "Head Position Error"
				Case STATUS_HARDWARE_ERR03 : TextBox_Result.Text += "Fan Stop Error"
				Case STATUS_HARDWARE_ERR04 : TextBox_Result.Text += "Cutter Error"
				Case STATUS_HARDWARE_ERR05 : TextBox_Result.Text += "Pinch Roller Error"
				Case STATUS_HARDWARE_ERR06 : TextBox_Result.Text += "Illegal Head Temperature"
				Case STATUS_HARDWARE_ERR07 : TextBox_Result.Text += "Illegal Media Temperature"
				Case STATUS_HARDWARE_ERR08 : TextBox_Result.Text += "Ribbon Tension Error"
				Case STATUS_HARDWARE_ERR09 : TextBox_Result.Text += "RFID Module Error"
				Case STATUS_HARDWARE_ERR10 : TextBox_Result.Text += "Illegal Motor Temperature"
			End Select
		ElseIf stat And GROUP_SYSTEM Then  '============= System error status group.

			TextBox_Result.Text += "SYSTEM ERROR"

		ElseIf stat And GROUP_FLSHPROG Then	 '=========== Flash rewriting staus group.

			TextBox_Result.Text += "FLSHPROG MODE"

		End If

	End Sub

	'********************* Get life counter
	Private Sub btnGetCounterL_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetCounterL.Click
		Dim c As Integer

		TextBox_Result.Text = "GetCounterL() value: "

		c = GetCounterL(DS820)
		If c >= 0 Then TextBox_Result.Text += Str(c) Else TextBox_Result.Text += "ERROR!"

	End Sub

	'********************* Get counter A
	Private Sub btnGetCounterA_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetCounterA.Click
		Dim c As Integer

		TextBox_Result.Text = "GetCounterA() value: "

		c = GetCounterA(DS820)
		If c >= 0 Then TextBox_Result.Text += Str(c) Else TextBox_Result.Text += "ERROR!"

	End Sub

	'********************* Get counter B
	Private Sub btnGetCounterB_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetCounterB.Click
		Dim c As Integer

		TextBox_Result.Text = "GetCounterB() value: "

		c = GetCounterB(DS820)
		If c >= 0 Then TextBox_Result.Text += Str(c) Else TextBox_Result.Text += "ERROR!"

	End Sub

	'********************** Get counter P
	Private Sub btnGetCounterP_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetCounterP.Click
		Dim c As Long

		TextBox_Result.Text = "GetCounterP() value: "

		c = GetCounterP(DS820)
		If c >= 0 Then TextBox_Result.Text += Str(c) Else TextBox_Result.Text += "ERROR!"

	End Sub

	'********************** Get counter Matte
	Private Sub btnGetCounterMatte_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetCounterMatte.Click
		Dim c As Integer

		TextBox_Result.Text = "GetCounterMatte() value: "

		c = GetCounterMatte(DS820)
		If c >= 0 Then TextBox_Result.Text += Str(c) Else TextBox_Result.Text += "ERROR!"

	End Sub

	'********************** Get counter M
	Private Sub btnGetCounterM_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetCounterM.Click
		Dim c As Integer

		TextBox_Result.Text = "GetCounterM() value: "

		c = GetCounterM(DS820)
		If c >= 0 Then TextBox_Result.Text += Str(c) Else TextBox_Result.Text += "ERROR!"

	End Sub

	'********************* Clear counter A
	Private Sub btnSetClearCounterA_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSetClearCounterA.Click

		TextBox_Result.Text = "SetClearCounterA() result: "

		If SetClearCounterA(DS820) <> False Then TextBox_Result.Text += "True" Else TextBox_Result.Text += "False"

	End Sub

	'********************* Clear counter B
	Private Sub btnSetClearCounterB_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSetClearCounterB.Click

		TextBox_Result.Text = "SetClearCounterB() result: "

		If SetClearCounterB(DS820) <> False Then TextBox_Result.Text += "True" Else TextBox_Result.Text += "False"

	End Sub

	'********************** Clear counter M
	Private Sub btnSetClearCounterM_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSetClearCounterM.Click

		TextBox_Result.Text = "SetClearCounterM() result: "

		If SetClearCounterM(DS820) <> False Then TextBox_Result.Text += "True" Else TextBox_Result.Text += "False"

	End Sub

	'********************** Set counter P
	Private Sub btnSetCounterP_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSetCounterP.Click

		TextBox_Result.Text = "SetCounterP() result: "

		If SetCounterP(DS820, CInt(Text_CounterP.Text)) <> False Then TextBox_Result.Text += "True" Else TextBox_Result.Text += "False"

	End Sub

	'********************* Get the number of free image buffer
	Private Sub btnGetFreeBuffer_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetFreeBuffer.Click
		Dim c As Integer

		TextBox_Result.Text = "GetFreeBuffer() value: "

		c = GetFreeBuffer(DS820)
		If c >= 0 Then TextBox_Result.Text += Str(c) Else TextBox_Result.Text += "ERROR!"

	End Sub

	'********************* Get remaining print quantity
	Private Sub btnGetPQTY_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetPQTY.Click
		Dim c As Integer

		TextBox_Result.Text = "GetPQTY() value: "

		c = GetPQTY(DS820)
		If c >= 0 Then TextBox_Result.Text += Str(c) Else TextBox_Result.Text += "ERROR!"

	End Sub

	'********************* Get media counter
	Private Sub btnGetMediaCounter_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetMediaCounter.Click
		Dim c As Integer

		TextBox_Result.Text = "GetMediaCounter() value: "

		c = GetMediaCounter(DS820)
		If c >= 0 Then TextBox_Result.Text += Str(c) Else TextBox_Result.Text += "ERROR!"

	End Sub

	'********************* Get media counter(HalfSize)
	Private Sub btnGetMediaCounterH_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetMediaCounterH.Click
		Dim c As Integer

		TextBox_Result.Text = "GetMediaCounterH() value: "

		c = GetMediaCounterH(DS820)
		If c >= 0 Then TextBox_Result.Text += Str(c) Else TextBox_Result.Text += "ERROR!"

	End Sub

	'********************* Get media counter default value
	Private Sub btnGetInitialMediaCount_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetInitialMediaCount.Click
		Dim c As Long

		TextBox_Result.Text = "GetInitialMediaCount() value: "

		c = GetInitialMediaCount(DS820)
		If c >= 0 Then TextBox_Result.Text += Str(c) Else TextBox_Result.Text += "ERROR!"
	End Sub

	'******************** Get media color offset value
	Private Sub btnGetMediaColorOffset_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetMediaColorOffset.Click
		Dim s As String = New String("", 255)
		Dim l As Integer

		TextBox_Result.Text = "GetMediaColorOffset() value: "

		l = GetMediaColorOffset(DS820)
		If l >= 0 Then
			s = VB.Right("0" & Hex(l), 8)
			TextBox_Result.Text += s
		Else
			TextBox_Result.Text += "ERROR!"
		End If

	End Sub

	'********************* Get media lot information
	Private Sub btnGetMediaLotNo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetMediaLotNo.Click
		Dim s As String = New String("", 255)
		Dim l As Integer

		TextBox_Result.Text = "GetMediaLotNo() value: "

		l = GetMediaLotNo(DS820, s)
		If l >= 0 Then TextBox_Result.Text += VB.Left(s, l) Else TextBox_Result.Text += "ERROR!"

	End Sub

	'********************* Get media class data in RFID
	Private Sub btnGetRfidMediaClass_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetRfidMediaClass.Click
		Dim s As String = New String("", 255)
		Dim c As Long

		TextBox_Result.Text = "GetRfidMediaClass() value: "

		c = GetRfidMediaClass(DS820, s)
		If c >= 0 Then TextBox_Result.Text += "(" + c.ToString + ")" + s Else TextBox_Result.Text += "ERROR!"
	End Sub

	'********************* Get reserved data in RFID
	Private Sub btnGetRfidReserveData_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetRfidReserveData.Click
		Dim s As String = New String("", 255)
		Dim c As Long

		TextBox_Result.Text = "GetRfidReserveData() value: "

		c = GetRfidReserveData(DS820, s, 1)
		If c >= 0 Then TextBox_Result.Text += "(" + c.ToString + ")" + s Else TextBox_Result.Text += "ERROR!"
	End Sub

	'********************* Get serial number
	Private Sub btnGetSerialNo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetSerialNo.Click
		Dim s As String = New String("", 255)
		Dim l As Integer

		TextBox_Result.Text = "GetSerialNo() value: "

		l = GetSerialNo(DS820, s)
		If l >= 0 Then TextBox_Result.Text += VB.Left(s, l) Else TextBox_Result.Text += "ERROR!"

	End Sub

	'********************* Set config to use iSerialNo of USB.
	Private Sub btnSetUSBSerialEnable_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSetUSBSerialEnable.Click
		Static lEnable As Integer = 1

		TextBox_Result.Text = "SetUSBSerialEnable() result: "

		If SetUSBSerialEnable(DS820, lEnable) <> False Then TextBox_Result.Text += "True" Else TextBox_Result.Text += "False"
		If lEnable = 1 Then lEnable = 0 Else lEnable = 1
	End Sub

	'********************* Get use condition to iSerila of USB.
	Private Sub btnGetUSBSerialEnable_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetUSBSerialEnable.Click
		Dim c As Long

		TextBox_Result.Text = "GetUSBSerialEnable() value: "
		c = GetUSBSerialEnable(DS820)
		If c >= 0 Then TextBox_Result.Text += c.ToString Else TextBox_Result.Text += "ERROR!"
	End Sub

	'********************* Clear color data
	Private Sub btnSetColorDataClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSetColorDataClear.Click
		TextBox_Result.Text = "SetColorDataClear() result: "

		If SetColorDataClear(DS820) <> False Then TextBox_Result.Text += "True" Else TextBox_Result.Text += "False"
	End Sub

	'********************* Set version of color data
	Private Sub btnSetColorDataVersion_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
		Dim s As String = "TestColor"

		TextBox_Result.Text = "SetColorDataVersion() result: "

		If SetColorDataVersion(DS820, s, s.Length) <> False Then TextBox_Result.Text += "True" Else TextBox_Result.Text += "False"
	End Sub

	'********************* Get color data version
	Private Sub btnGetColorDataVersion_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetColorDataVersion.Click
		Dim s As String = New String("", 255)
		Dim l As Integer

		TextBox_Result.Text = "GetColorDataVersion() value: "

		l = GetColorDataVersion(DS820, s)
		If l >= 0 Then TextBox_Result.Text += VB.Left(s, l) Else TextBox_Result.Text += "ERROR!" : Exit Sub

	End Sub

	'********************* Get checksum of color data
	Private Sub btnGetColorDataChecksum_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetColorDataChecksum.Click
		Dim s As String = New String("", 255)
		Dim l As Integer

		TextBox_Result.Text = "GetColorDataChecksum() value: "

		l = GetColorDataChecksum(DS820, s)
		If l >= 0 Then TextBox_Result.Text += VB.Left(s, l) Else TextBox_Result.Text += "ERROR!"

	End Sub

	'*********************  Get version of color data with type
	Private Sub btnGetColorDataVersionRes_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetColorDataVersionRes.Click
		Dim s As String = New String("", 255)
		Dim ver As String
		Dim l As Integer
		Dim i As Integer

		TextBox_Result.Text = ""

		For i = 0 To 3
			TextBox_Result.Text += "GetColorDataVersionRes() value: "

			l = GetColorDataVersionRes(DS820, s, i)
			If l >= 0 Then ver = VB.Left(s, l) Else ver = "ERROR!"

			TextBox_Result.Text += ver + vbCrLf
		Next
	End Sub

	'********************* Get checksum of color data with type
	Private Sub btnGetColorDataChecksumRes_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetColorDataChecksumRes.Click
		Dim s As String = New String("", 255)
		Dim cs As String
		Dim l As Integer
		Dim i As Integer

		TextBox_Result.Text = ""

		For i = 0 To 3
			TextBox_Result.Text += "GetColorDataChecksumRes() value: "

			l = GetColorDataChecksumRes(DS820, s, i)
			If l >= 0 Then cs = VB.Left(s, l) Else cs = "ERROR!"

			TextBox_Result.Text += cs + vbCrLf
		Next

	End Sub

	'********************* Set cutter non scarp mode
	Private Sub btnSetCutterMode_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSetCutterMode.Click
		Static lMode As Integer = CUTTER_MODE_STANDARD

		If lMode = CUTTER_MODE_STANDARD Then
			lMode = CUTTER_MODE_NONSCRAP
			TextBox_Result.Text = "SetCutterMode(CUTTER_MODE_NONSCRAP)"
		ElseIf lMode = CUTTER_MODE_NONSCRAP Then
			lMode = CUTTER_MODE_2INCHCUT
			TextBox_Result.Text = "SetCutterMode(CUTTER_MODE_2INCHCUT)"
		ElseIf lMode = CUTTER_MODE_2INCHCUT Then
			lMode = CUTTER_MODE_PANORAMA
			TextBox_Result.Text = "SetCutterMode(CUTTER_MODE_PANORAMA)"
		Else
			lMode = CUTTER_MODE_STANDARD
			TextBox_Result.Text = "SetCutterMode(CUTTER_MODE_STANDARD)"
		End If

		If SetCutterMode(DS820, lMode) <> False Then TextBox_Result.Text += " result: True" Else TextBox_Result.Text += " result: False"

	End Sub

	'********************* Set fullcutter setting
	Private Sub btnSetFullCutterSetup_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSetFullCutterSetup.Click
		Dim s As String = New String("", 255)
		Dim i1, i2, i3, i4, i5, i6 As Integer

		TextBox_Result.Text = "SetFullCutterSetup() result: "

		i1 = CInt(TextBox_Cut1.Text)
		i2 = CInt(TextBox_Cut2.Text)
		i3 = CInt(TextBox_Cut3.Text)
		i4 = CInt(TextBox_Cut4.Text)
		i5 = CInt(TextBox_Cut5.Text)
		i6 = CInt(TextBox_Cut6.Text)

		If SetFullCutterSetup(DS820, i1, i2, i3, i4, i5, i6) <> False Then TextBox_Result.Text += "True" Else TextBox_Result.Text += "False"
	End Sub

	'********************* Set fullcutter setting. (with the cutting dust size)
	Private Sub btnSetFullCutterSetupEX_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSetFullCutterSetupEX.Click
		Dim s As String = New String("", 255)
		Dim i1, i2, i3, i4, i5, i6, ds As Integer

		TextBox_Result.Text = "SetFullCutterSetupEx() result: "

		i1 = CInt(TextBox_CutEx1.Text)
		i2 = CInt(TextBox_CutEx2.Text)
		i3 = CInt(TextBox_CutEx3.Text)
		i4 = CInt(TextBox_CutEx4.Text)
		i5 = CInt(TextBox_CutEx5.Text)
		i6 = CInt(TextBox_CutEx6.Text)
		ds = CInt(TextBox_CutExDS.Text)

		If SetFullCutterSetupEX(DS820, i1, i2, i3, i4, i5, i6, ds) <> False Then TextBox_Result.Text += "True" Else TextBox_Result.Text += "False"
	End Sub

	'********************* Set standby mode transition time
	Private Sub btnSetStandbyTime_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSetStandbyTime.Click

		TextBox_Result.Text = "SetStandbyTime() result: "

		If SetStandbyTime(DS820, CInt(TextBox_Min.Text)) Then TextBox_Result.Text += "True" Else TextBox_Result.Text += "False"
	End Sub

	'********************* Get standby mode transition time
	Private Sub btnGetStandbyTime_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetStandbyTime.Click
		Dim i As Long

		TextBox_Result.Text = "GetStandbyTime() value: "

		i = GetStandbyTime(DS820)
		If i >= 0 Then TextBox_Result.Text += Str(i) Else TextBox_Result.Text += "ERROR!"
	End Sub

	'********************* Switch the end keep mode
	Private Sub btnSetEndKeepMode_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSetEndKeepMode.Click
		Static lMode As Integer = 1

		TextBox_Result.Text = "SetEndKeepMode() result: "

		If SetEndKeepMode(DS820, lMode) <> 0 Then TextBox_Result.Text += "True" Else TextBox_Result.Text += "False"

		If lMode = 1 Then lMode = 0 Else lMode = 1
	End Sub

	'********************* Confirm the end keep mode is enabled 
	Private Sub btnGetEndKeepMode_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetEndKeepMode.Click
		Dim i As Integer

		TextBox_Result.Text = "GetEndKeepMode() value: "

		i = GetEndKeepMode(DS820)
		If i >= 0 Then TextBox_Result.Text += Str(i) Else TextBox_Result.Text += "ERROR!"
	End Sub

	'********************* Confirm be able to panorama print
	Private Sub btnGetPanoramaPrintable_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetPanoramaPrintable.Click
		Dim i As Integer

		TextBox_Result.Text = "GetPanoramaPrintable() value: "

		i = GetPanoramaPrintable(DS820)
		If i >= 0 Then TextBox_Result.Text += Str(i) Else TextBox_Result.Text += "ERROR!"
	End Sub

	'********************* Set overcoat finish
	Private Sub btnSetOvercoatFinish_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSetOvercoatFinish.Click
		Static lType As Integer = OVERCOAT_FINISH_GLOSSY

		If lType = OVERCOAT_FINISH_GLOSSY Then
			lType = OVERCOAT_FINISH_MATTE1
			TextBox_Result.Text = "SetOvercoatFinish(OVERCOAT_FINISH_MATTE1)"
		ElseIf lType = OVERCOAT_FINISH_MATTE1 Then
			lType = OVERCOAT_FINISH_FINEMATTE
			TextBox_Result.Text = "SetOvercoatFinish(OVERCOAT_FINISH_FINEMATTE)"
		ElseIf lType = OVERCOAT_FINISH_FINEMATTE Then
			lType = OVERCOAT_FINISH_LUSTER
			TextBox_Result.Text = "SetOvercoatFinish(OVERCOAT_FINISH_LUSTER)"
		ElseIf lType = OVERCOAT_FINISH_LUSTER Then
			lType = OVERCOAT_FINISH_HSMATTE
			TextBox_Result.Text = "SetOvercoatFinish(OVERCOAT_FINISH_HSMATTE)"
		ElseIf lType = OVERCOAT_FINISH_HSMATTE Then
			lType = OVERCOAT_FINISH_PMATTE11
			TextBox_Result.Text = "SetOvercoatFinish(OVERCOAT_FINISH_PMATTE11)"
		ElseIf lType = OVERCOAT_FINISH_PMATTE11 Then
			lType = OVERCOAT_FINISH_PMATTE12
			TextBox_Result.Text = "SetOvercoatFinish(OVERCOAT_FINISH_PMATTE12)"
		ElseIf lType = OVERCOAT_FINISH_PMATTE12 Then
			lType = OVERCOAT_FINISH_PMATTE13
			TextBox_Result.Text = "SetOvercoatFinish(OVERCOAT_FINISH_PMATTE13)"
		Else
			lType = OVERCOAT_FINISH_GLOSSY
			TextBox_Result.Text = "SetOvercoatFinish(OVERCOAT_FINISH_GLOSSY)"
		End If

		If SetOvercoatFinish(DS820, lType) <> False Then TextBox_Result.Text += " result: True" Else TextBox_Result.Text += " result: False"
	End Sub

	'********************* Set print speed
	Private Sub btnSetPrintSpeed_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSetPrintSpeed.Click
		Static lPrintSpeed As Integer = PRINTSPEED_NORMAL

		If lPrintSpeed = PRINTSPEED_NORMAL Then
			lPrintSpeed = PRINTSPEED_HIGH_DENSITY
			TextBox_Result.Text = "SetPrintSpeed(High density printing)"
		Else
			lPrintSpeed = PRINTSPEED_NORMAL
			TextBox_Result.Text = "SetPrintSpeed(Normal printing)"
		End If

		If SetPrintSpeed(DS820, lPrintSpeed) <> False Then TextBox_Result.Text += " result: True" Else TextBox_Result.Text += " result: False"
	End Sub

	'*********************  Get version of color data with type & media
	Private Sub btnGetColorDataVersionResEX_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetColorDataVersionResEX.Click
		Static lMedia As Integer = MEDIA_RX
		Dim s As String = New String("", 255)
		Dim media As String
		Dim ver As String
		Dim l As Integer
		Dim i As Integer

		If lMedia = MEDIA_RX Then
			lMedia = MEDIA_HDM
			media = "[Media = PP ] "
		Else
			lMedia = MEDIA_RX
			media = "[Media = SD ] "
		End If

		TextBox_Result.Text = ""

		For i = 0 To 3
			TextBox_Result.Text += "GetColorDataVersionResEX() value: " & media

			l = GetColorDataVersionResEX(DS820, s, i, lMedia)
			If l >= 0 Then ver = VB.Left(s, l) Else ver = "ERROR!"

			TextBox_Result.Text += ver + vbCrLf
		Next
	End Sub

	'********************* Get checksum of color data with type & media
	Private Sub btnGetColorDataChecksumResEX_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetColorDataChecksumResEX.Click
		Static lMedia As Integer = MEDIA_RX
		Dim s As String = New String("", 255)
		Dim media As String
		Dim cs As String
		Dim l As Integer
		Dim i As Integer

		If lMedia = MEDIA_RX Then
			lMedia = MEDIA_HDM
			Media = "[Media = PP ] "
		Else
			lMedia = MEDIA_RX
			Media = "[Media = SD ] "
		End If

		TextBox_Result.Text = ""

		For i = 0 To 3
			TextBox_Result.Text += "GetColorDataChecksumResEX() value: " & media

			l = GetColorDataChecksumResEX(DS820, s, i, lMedia)
			If l >= 0 Then cs = VB.Left(s, l) Else cs = "ERROR!"

			TextBox_Result.Text += cs + vbCrLf
		Next

	End Sub

End Class